#include "databox.h"
#include "scene.h"

/* $B%G!<%?%\%C%/%9$N%G!<%?$rFI$_9~$`(B */
void loaddatabox(W bwid)
{
    DBOX_HDR headder;
    DTYP_INX typindex;
    DNUM_INX numindex;
    W i, j, k, l, m, offset, err, noffset, type, pos, pos2, size, size2,
      size3, off, kdatnum;
    
    PatKind    pkind;
    PAT        *patdat;
    CBMP       *cbmp;

    W partstype;
    PARTSDATA  *pdat;
    PARTS_SDAT *psdat;
    PARTDISP   *patr;
    
    TC *tc;
    MENUDATA  *mdat;
    GMENUDATA *gmdat;
    PANELDATA *pnldat;

    /* $B=i4|@_Dj(B */
    for (i = 1 ; i <= 10 ; i++) {
	datanum[i] = 0;
    }
    
    offset = 0;

    if ((err = fnd_rec(myfd, F_TOPEND, 1 << 10, (UH)NULL, NULL)) != 10) {
	for (i = 0 ; i < 11 ; i++) {
	    wdat.selectnum[i] = -1;
	    wdat.selectnumsub1[i] = 0;
	    wdat.selectnumsub2[i] = 0;
	    wdat.pnt[i].x = 0;
	    wdat.pnt[i].y = 0;
	}
	selectnum = -1;
	return;
    }
    if ((err = rea_rec(myfd, 0, (B *)&headder,
		       sizeof(DBOX_HDR), NULL, (UH)NULL)) < 0) {
	printerror(2);
	return;
    }
  
    noffset = sizeof(DBOX_HDR);
    
printf("load start\n");
printf("number of type %d\n", headder.ntyp);
    
    for (i = 0 ; i < headder.ntyp ; i++) {
	set_window_bar(bwid, i, headder.ntyp);
	offset = noffset;
	if ((err = rea_rec(myfd, noffset, (B *)&typindex,
			   sizeof(DTYP_INX)- sizeof(DNUM_INX), NULL,
			   (UH)NULL)) < 0) {
	    printerror(2);
	    return;
	}
	offset += sizeof(DTYP_INX) - sizeof(DNUM_INX);
	noffset = typindex.npos;

	type = typindex.typ;

	/* $B%G!<%?%?%$%W$,(B1$B!A(B10$B0J30$O%5%]!<%H$7$J$$(B */
	if (type < 1 || type > 10) {
	    continue;
	}
	
	datanum[type] = typindex.nd;
	if (datanum[type] > DATAMAX) {
	    datanum[type] = DATAMAX;
	}
	
printf("type %d num %d\n", type, datanum[type]);    
	
	for (j = 0 ; j < datanum[type] ; j++) {
/*printf("no.%d\n", j);*/
	    if ((err = rea_rec(myfd, offset, (B *)&numindex,
			       sizeof(DNUM_INX), NULL, (UH)NULL)) < 0) {
		printerror(2);
		return;
	    }
	    offset += sizeof(DNUM_INX);
	    data[type][j].id = numindex.id;

	    switch (type) {
	    case PTR_DATA:
		data[type][j].ptr    = checkmalloc(sizeof(PTRDATA));
		if ((err = rea_rec(myfd, numindex.pos,
				   (B *)data[type][j].ptr,
				   numindex.size, NULL, (UH)NULL)) < 0) {
		    printerror(2);
		    break;
		}
		break;
	    case PAT_DATA:
		data[type][j].ptr    = checkmalloc(sizeof(PAT));
		patdat = (PAT *)data[type][j].ptr;
		data[type][j].length = numindex.size;		
		if ((err = rea_rec(myfd, numindex.pos, (B *)&pkind,
			sizeof(PatKind), NULL, (UH)NULL)) < 0) {
		    printerror(2);
		    break;
		}
		pos = numindex.pos;
		if (pkind == 0) {
		    size = sizeof(PatKind) + sizeof(UH) * 2 +
			sizeof(COLOR) * 2 + sizeof(UB *);
		    if ((err = rea_rec(myfd, pos,
				       (B *)&(patdat->spat),
				       size, NULL, (UH)NULL)) < 0) {
			printerror(2);
			break;
		    }
		    size2 = ((patdat->spat.hsize + 15) / 16) * 2 *
			patdat->spat.vsize;
		    off = (W)patdat->spat.mask;
		    patdat->spat.mask = checkmalloc(size2);
		    if ((err = rea_rec(myfd, pos + off,
				       (B *)patdat->spat.mask,
				       size2, NULL, (UH)NULL)) < 0) {
			printerror(2);
			break;
		    }
		}
		else {
		    size = sizeof(PatKind) + sizeof(UH) * 2 +
			sizeof(UB *) + sizeof(BMP *);
		    if ((err = rea_rec(myfd, pos,
				       (B *)&(patdat->mpat),
				       size, NULL, (UH)NULL)) < 0) {
			printerror(2);
			break;
		    }
		    off = (W)patdat->mpat.mask;
		    size3 = ((patdat->spat.hsize + 15) / 16) * 2 *
			patdat->spat.vsize;
		    patdat->mpat.mask = checkmalloc(size3);
		    if ((err = rea_rec(myfd, pos + off,
				       (B *)(patdat->mpat.mask),
				       size3, NULL, (UH)NULL)) < 0) {
			printerror(2);
			break;
		    }

		    data[type][j].length = size2 = numindex.size -
			size - size3;
		    off = (W)patdat->mpat.bmap;
		    patdat->mpat.bmap = (BMP *)checkmalloc(size2);
		    if ((err = rea_rec(myfd, pos + off,
				       (B *)patdat->mpat.bmap,
				       size2, NULL, (UH)NULL)) < 0) {
			printerror(2);
			break;
		    }
		    size2 = patdat->mpat.bmap->rowbytes *
			(patdat->mpat.bmap->bounds.c.bottom -
			 patdat->mpat.bmap->bounds.c.top);
		    for (k = 0 ; k < patdat->mpat.bmap->planes ; k++) {
			patdat->mpat.bmap->baseaddr[k] =
			    (B *)(patdat->mpat.bmap) + sizeof(BMP) +
			    size2 * k +
			    (patdat->mpat.bmap->planes - 1) * sizeof(UB);
		    }
		    getscreentypebmp(patdat->mpat.bmap, type, j);
		}
		break;
	    case PICT_DATA:
	    case BMAP_DATA: /* $B%S%C%H%^%C%W%G!<%?(B */
		data[type][j].ptr    = checkmalloc(numindex.size);
		data[type][j].length = numindex.size;		
		if ((err = rea_rec(myfd, numindex.pos, data[type][j].ptr,
			numindex.size, NULL, (UH)NULL)) < 0) {
		    printerror(2);
		    break;
		}
		cbmp = (CBMP *)(data[type][j].ptr);
		size = cbmp->bmp.rowbytes * (cbmp->bmp.bounds.c.bottom -
					     cbmp->bmp.bounds.c.top);
		for (k = 0 ; k < cbmp->bmp.planes ; k++) {
		    cbmp->bmp.baseaddr[k] = (B *)(cbmp) + sizeof(CBMP) +
			     size * k + (cbmp->bmp.planes - 1) * sizeof(UB);
		}
		getscreentypebmp(&(cbmp->bmp), type, j);
		break;
	    case FIG_DATA:
		data[type][j].ptr    = checkmalloc(numindex.size);
		if ((err = rea_rec(myfd, numindex.pos, data[type][j].ptr,
			numindex.size, NULL, (UH)NULL)) < 0) {
		    printerror(2);
		    break;
		}
		break;
	    case TEXT_DATA: /* $BJ8;zNs%G!<%?(B */
		data[type][j].ptr    = checkmalloc(numindex.size);
		data[type][j].length = numindex.size;
		if ((err = rea_rec(myfd, numindex.pos, data[type][j].ptr,
			numindex.size, NULL, (UH)NULL)) < 0) {
		    printerror(2);
		    break;
		}
		break;
	    case PARTS_DATA:
		pos = numindex.pos;
		if ((err = rea_rec(myfd, pos, (B *)&partstype,
			sizeof(W), NULL, (UH)NULL)) < 0) {		    
		    goto PARTS_ERROR;
		}
		if ((partstype & 0x1f) != SB_PARTS) {
		    kdatnum = ((partstype & 0x1f) == WS_PARTS) ? 31 :
			((partstype & 0x1f) == SS_PARTS) ? 63 : 0;
		    data[type][j].ptr = (B *)checkmalloc(sizeof(PARTSDATA) +
					      kdatnum * sizeof(PARTS_KDAT));
		    pdat = (PARTSDATA *)data[type][j].ptr;
		    for (l = 0 ; l <= kdatnum ; l++) {
			pdat->kdat[l].chcol   = -1;
			pdat->kdat[l].class   = -1;
			pdat->kdat[l].fattr   = 0;
			pdat->kdat[l].csize.x = 16;
			pdat->kdat[l].csize.y = 16;
			pdat->kdat[l].dtype   = 0;
			pdat->kdat[l].dnum    = 0;
			pdat->kdat[l].length  = 1;
		    }
		}
		else {
		    data[type][j].ptr = (B *)checkmalloc(sizeof(PARTSDATA) -
			    sizeof(PARTS_KDAT) + sizeof(PARTS_SDAT) * 16);
		    pdat = (PARTSDATA *)data[type][j].ptr;
		    psdat = (PARTS_SDAT *)(pdat->kdat);
		    for (l = 0 ; l < 16 ; l++) {
			for (m = 0 ; m < 32 ; m++) {
			    psdat[l].kdat[m].chcol   = -1;
			    psdat[l].kdat[m].class   = -1;
			    psdat[l].kdat[m].fattr   = 0;
			    psdat[l].kdat[m].csize.x = 16;
			    psdat[l].kdat[m].csize.y = 16;
			    psdat[l].kdat[m].dtype   = 0;
			    psdat[l].kdat[m].dnum    = 0;
			    psdat[l].kdat[m].length  = 1;
			}
		    }
		}
		switch (partstype & 0x1f) {
		case TB_PARTS:
		case XB_PARTS:
		    /* $B%F%-%9%H%\%C%/%9$O$J$<$+(B-1$B$OF)L@?'$J$N$G(B
		       $B9u$r%G%U%)%k%H$K;XDj(B */
		    pdat->kdat[0].chcol   = 255;
		    pdat->parts.tb.atr.misc = -1;
		    size = sizeof(TEXTBOX) -
			((partstype & P_PARTDISP) ? 0 : sizeof(PARTDISP));
		    if ((err = rea_rec(myfd, pos, (B *)&(pdat->parts.tb),
				       size, NULL, (UH)NULL)) < 0) {
			goto PARTS_ERROR;
		    }
		    pdat->ptrlen = size = numindex.size - size;
		    pos2 = numindex.pos + (W)(pdat->parts.tb.text);
		    pdat->parts.tb.text = (TC *)checkmalloc(size);
		    if ((err = rea_rec(myfd, pos2,
				       (B *)(pdat->parts.tb.text),
				       size, NULL, (UH)NULL)) < 0) {
			goto PARTS_ERROR;
		    }
		    break;
		case NB_PARTS:
		    pdat->parts.nb.atr.misc = -1;
		    size = sizeof(NUMBOX) -
			((partstype & P_PARTDISP) ? 0 : sizeof(PARTDISP));
		    if ((err = rea_rec(myfd, pos, (B *)&(pdat->parts.nb),
				       size, NULL, (UH)NULL)) < 0) {
			goto PARTS_ERROR;
		    }
		    break;
		case SB_PARTS:
		    pdat->parts.sb.atr.misc = -1;
		    size = sizeof(SERBOX) -
			((partstype & P_PARTDISP) ? 0 : sizeof(PARTDISP));
		    if ((err = rea_rec(myfd, pos, (B *)&(pdat->parts.sb),
				       size, NULL, (UH)NULL)) < 0) {
			goto PARTS_ERROR;
		    }

		    pos2 = numindex.pos + (W)(pdat->parts.sb.cv);
		    pdat->parts.sb.cv = (W *)checkmalloc(sizeof(W) * 16);
		    if ((err = rea_rec(myfd, pos2,
				       (B *)(pdat->parts.sb.cv),
				       sizeof(W) * (pdat->parts.sb.nfld),
				       NULL, (UH)NULL)) < 0) {
			goto PARTS_ERROR;
		    }
		    		    
		    pdat->ptrlen = size = numindex.size - size -
			(pdat->parts.sb.nfld) * sizeof(W);
		    pos2 = numindex.pos + (W)(pdat->parts.sb.fmt);
		    pdat->parts.sb.fmt = (TC *)checkmalloc(size);
		    if ((err = rea_rec(myfd, pos2,
				       (B *)(pdat->parts.sb.fmt),
				       size, NULL, (UH)NULL)) < 0) {
			goto PARTS_ERROR;
		    }
		    break;
		case AS_PARTS: /* $B%F%-%9%H%*%k%?%M!<%H%9%$%C%A(B */
		case MS_PARTS: /* $B%F%-%9%H%b!<%a%s%?%j%9%$%C%A(B */
		case WS_PARTS: /* $B%9%$%C%A%;%l%/%?(B */
		case SS_PARTS: /* $B%9%/%m!<%k%;%l%/%?(B */
		    pdat->parts.tb.atr.misc = 0;
		    size = sizeof(SWSEL) -
			((partstype & P_PARTDISP) ? 0 : sizeof(PARTDISP));
		    if ((err = rea_rec(myfd, pos, (B *)&(pdat->parts.ss),
				       size, NULL, (UH)NULL)) < 0) {
			goto PARTS_ERROR;
		    }
		    pdat->ptrlen = size = numindex.size - size;
		    pos2 = numindex.pos + (W)(pdat->parts.ss.name);
		    pdat->parts.ss.name = (TC *)checkmalloc(size);
		    if ((err = rea_rec(myfd, pos2,
				       (B *)(pdat->parts.ss.name),
				       size, NULL, (UH)NULL)) < 0) {
			goto PARTS_ERROR;
		    }
		    break;
		case PA_PARTS:
		case PM_PARTS:
		    size = sizeof(PICTSW) -
			((partstype & P_PARTDISP) ? 0 : sizeof(PARTDISP));
		    if ((err = rea_rec(myfd, pos, (B *)&(pdat->parts.pw),
				       size, NULL, (UH)NULL)) < 0) {
			goto PARTS_ERROR;
		    }
		    break;
		case VL_PARTS:
		    size = sizeof(VOLUME) -
			((partstype & P_PARTDISP) ? 0 : sizeof(PARTDISP));
		    if ((err = rea_rec(myfd, pos, (B *)&(pdat->parts.vl),
				       size, NULL, (UH)NULL)) < 0) {
			goto PARTS_ERROR;
		    }
		    break;
		}
		if (!(partstype & P_PARTDISP)) {
		    getpatr(pdat, &patr);
		    patr->frpat = 0;
		    patr->bgpat = 0;
		    patr->chcol = -1;
		}
		pdat->pid = 0;
		/* pdat->pid = ccre_par(winfo[0].wid,
					 (PARTS *)&(pdat->parts)); */
/*printf("partstype %d id %d\n", partstype & 0x1f, pdat->pid);*/
		parseparts(pdat, partstype & 0x001f);
		break;
	    PARTS_ERROR:
		printerror(2);
		pdat->knum = 0;
		break;
	    case MENU_DATA:
		data[type][j].ptr    = (B *)checkmalloc(sizeof(MENUDATA));
		mdat = (MENUDATA *)data[type][j].ptr;
		/* $B%a%K%e!<9`L\%/%j%"(B */
		for (k = 0 ; k < 32 ; k++) {
		    mdat->mitem[k].ptr = NULL;
		}
		pos = numindex.pos;
		if ((err = rea_rec(myfd, pos, (B *)mdat,
			sizeof(W), NULL, (UH)NULL)) < 0) {		    
		    goto MENU_ERROR;
		}
		mdat->menudisp = 0;
		pos += sizeof(W);
		if (mdat->nitem & 0x8000) {
		    mdat->nitem -= 0x8000;
		    mdat->menudisp = 1;
		    if ((err = rea_rec(myfd, pos, (B *)(&(mdat->mdisp)),
			       sizeof(MENUDISP), NULL, (UH)NULL)) < 0) {
			goto MENU_ERROR;
		    }
		    pos += sizeof(MENUDISP) + sizeof(W) * 2;
		}
		else {
		    mdat->mdisp.m_frame  = 0;
		    mdat->mdisp.s_frame  = 0;
		    mdat->mdisp.m_bgpat  = 0;
		    mdat->mdisp.s_bgpat  = 0;
		    mdat->mdisp.s_indpat = 0;
		    mdat->mdisp.m_chcol  = -1;
		    mdat->mdisp.s_chcol  = -1;
		    mdat->mdisp.s_keycol = -1;
		}

		for (l = 0 ; l < mdat->nitem ; l++) {
		    if ((err = rea_rec(myfd, pos, (B *)(&mdat->mitem[l]),
			        sizeof(MENUITEM), NULL, (UH)NULL)) < 0) {
			goto MENU_ERROR;
		    }
		    pos += sizeof(MENUITEM);
		}
		for (l = 0 ; l < mdat->nitem ; l++) {
		    for (m = 0 ; m < 32 ; m++) {
			mdat->kdat[l][m].chcol   = -1;
			mdat->kdat[l][m].class   = -1;
			mdat->kdat[l][m].fattr   = 0;
			mdat->kdat[l][m].csize.x = 16;
			mdat->kdat[l][m].csize.y = 16;
			mdat->kdat[l][m].dtype   = 0;
			mdat->kdat[l][m].dnum    = 0;
			mdat->kdat[l][m].length  = 1;
			mdat->kdat[l][m].keynum  = 0;
			mdat->kdat[l][m].keyon   = 0;
		    }

		    if (mdat->mitem[l].dnum == 0) {
			mdat->ptrlen[l] = size = ((l == (mdat->nitem - 1)) ?
			    numindex.size :
				(W)(mdat->mitem[l+1].ptr)) -
				    (W)(mdat->mitem[l].ptr);
			pos2 = numindex.pos + (W)(mdat->mitem[l].ptr);
			mdat->mitem[l].ptr = (TC *)checkmalloc(size);
			if ((err = rea_rec(myfd, pos2,
					   (B *)(mdat->mitem[l].ptr),
					   size, NULL, (UH)NULL)) < 0) {
			    goto MENU_ERROR;
			}
		    }
		    else {
			gettextdata(mdat->mitem[l].dnum,
				    (TC **)&(mdat->mitem[l].ptr));
		    }
		}
		parsemenu(mdat);
		break;
	    MENU_ERROR:
		printerror(2);
		mdat->nitem = 0;
		break;
	    case GMENU_DATA:
		data[type][j].ptr    = (B *)checkmalloc(sizeof(GMENUDATA));
		gmdat = (GMENUDATA *)data[type][j].ptr;

		for (l = 0 ; l < 32 ; l++) {
		    gmdat->gkdat[l].chcol   = -1;
		    gmdat->gkdat[l].class   = -1;
		    gmdat->gkdat[l].fattr   = 0;
		    gmdat->gkdat[l].csize.x = 16;
		    gmdat->gkdat[l].csize.y = 16;
		    gmdat->gkdat[l].dtype   = 0;
		    gmdat->gkdat[l].dnum    = 0;
		}
		
		pos = numindex.pos;
		if ((err = rea_rec(myfd, pos, (B *)&(gmdat->gmenu),
			sizeof(GMENU) - sizeof(RECT) * 32,
				   NULL, (UH)NULL)) < 0) {		    
		    goto GMENU_ERROR;
		}
		pos += sizeof(GMENU) - sizeof(RECT) * 32;
		if ((err = rea_rec(myfd, pos, (B *)(gmdat->gmenu.r),
				   sizeof(RECT) * gmdat->gmenu.nitem,
				   NULL, (UH)NULL)) < 0) {		    
		    goto GMENU_ERROR;
		}
		pos += sizeof(RECT) * gmdat->gmenu.nitem;

		if (gmdat->gmenu.dnum == 0) {
		    gmdat->ptrlen = size =
			numindex.size - (pos - numindex.pos);
		    gmdat->gmenu.ptr = (TC *)checkmalloc(size);
		    if ((err = rea_rec(myfd, pos,
				       (B *)(gmdat->gmenu.ptr),
				       size, NULL, (UH)NULL)) < 0) {
			goto GMENU_ERROR;
		    }
		}
		else {
		    gettextdata(gmdat->gmenu.dnum,
				(TC **)&(gmdat->gmenu.ptr));
		}
		parsegmenu(gmdat);
		break;
	    GMENU_ERROR:
		printerror(2);
		mdat->nitem = 0;
		break;
	    case PANEL_DATA:
		data[type][j].ptr    = (B *)checkmalloc(sizeof(PANELDATA));
		pnldat = (PANELDATA *)data[type][j].ptr;

		for (l = 0 ; l < 32 ; l++) {
		    pnldat->pid[l] = 0;
		}
		
		pos = numindex.pos;
		if ((err = rea_rec(myfd, pos, (B *)&(pnldat->panel),
			sizeof(PANEL) - sizeof(PNL_ITEM *),
				   NULL, (UH)NULL)) < 0) {		    
		    goto PANEL_ERROR;
		}
		pos += sizeof(PANEL) - sizeof(PNL_ITEM *);
		pnldat->panel.item =
		    (PNL_ITEM *)checkmalloc(sizeof(PNL_ITEM) * 32);
		if ((err = rea_rec(myfd, pos, (B *)(pnldat->panel.item),
				   sizeof(PNL_ITEM) * pnldat->panel.nitem,
				   NULL, (UH)NULL)) < 0) {		    
		    goto PANEL_ERROR;
		}
		break;
	    PANEL_ERROR:
		printerror(2);
		break;
	    }
	}
    }
printf("load ok.\n");
    for (i = 1 ; i <= 10 ; i++) {
	ichikeisan(i, 0);
    }

    return;    	
}

void loadcdata(W bwid)
{
    B headder[11];
    SCENEDATAver1_0 sdatver1_0;
    SCENEDATAver1_1 sdatver1_1;
    SCENEDATAver1_2 sdatver1_2;
    SCENEDATAver1_3 sdatver1_3;
    SCENEDATAver1_4 sdatver1_4;
    W i, first, ok, datanum, num, err, offset, filesize;
    CDATA *cdatptr;
    
    headder[10] = 0;
    first = 1;
    ok = 0;
    while (1) {       
	err = fnd_rec(myfd, (first) ? F_TOPEND : F_NFWD,
		      1 << 31, (UH)NULL, NULL);
	first = 0;
	if (err == 31) {
	    if ((err = rea_rec(myfd, 0, (B *)&headder,
			       sizeof(B) * 10, NULL, (UH)NULL)) < 0) {
		printerror(2);
		return;
	    }
	    if (!strncmp(headder, "SDATver1.0", 10)) {
		ok = 1;
		break;
	    }
	    if (!strncmp(headder, "SDATver1.1", 10)) {
		ok = 2;
		break;
	    }
	    if (!strncmp(headder, "SDATver1.2", 10)) {
		ok = 3;
		break;
	    }
	    if (!strncmp(headder, "SDATver1.3", 10)) {
		ok = 4;
		break;
	    }
	    if (!strncmp(headder, "SDATver1.4", 10)) {
		ok = 5;
		break;
	    }
	}
	else {
	    break;
	}
    }

    if (!ok) {
	printf("no scene data\n");
	return;
    }
    else {
	printf("scene data %s\n", headder);
    }

    if ((err = rea_rec(myfd, 0, NULL,
		       0, &filesize, NULL)) < 0) {
	printerror(3);
	return;
    }
    offset = sizeof(B) * 10;
    while (1) {
	if ((err = rea_rec(myfd, offset, (B *)&num,
			   sizeof(W), NULL, NULL)) < 0) {
	    printerror(3);
	    return;
	}
	if (num == -1) {
	    break;
	}
	offset += sizeof(W);
	
	printf("loading scenedata %d\n", num);
	
	if ((err = rea_rec(myfd, offset, (B *)&datanum,
			   sizeof(W), NULL, NULL)) < 0) {
	    printerror(3);
	    return;
	}
	offset += sizeof(W);

	cdatptr = cdata[num].data = (CDATA *)checkmalloc(sizeof(CDATA));
	cdatptr->plnk = NULL;
	
	for (i = 0 ; i < datanum ; i++) {
	    set_window_bar(bwid, offset, filesize);
	    switch (ok) {
	    case 1: /* ver1.0 */
		if ((err = rea_rec(myfd, offset, (B *)&sdatver1_0,
				   sizeof(SCENEDATAver1_0),
				   NULL, NULL)) < 0) {
		    printerror(3);
		    return;
		}
		offset += sizeof(SCENEDATAver1_0);
		cdatptr->type        = sdatver1_0.type;
		cdatptr->id          = sdatver1_0.id;
		cdatptr->pid         = 0;
		cdatptr->dispmode    = G_STORE;
		cdatptr->mojifgcolor = 255;
		cdatptr->mojibgcolor = 0;
		cdatptr->mojiattr    = 0;
		cdatptr->mojisize.x  = 16;
		cdatptr->mojisize.y  = 16;
		searchdnum2(cdatptr, &(cdatptr->r));
		posrect(&(cdatptr->r), sdatver1_0.r.p.lefttop);
		cdatptr->pnum        = sdatver1_0.pnum;
		break;
	    case 2: /* ver1.1 */
		if ((err = rea_rec(myfd, offset, (B *)&sdatver1_1,
				   sizeof(SCENEDATAver1_1),
				   NULL, NULL)) < 0) {
		    printerror(3);
		    return;
		}
		offset += sizeof(SCENEDATAver1_1);
		cdatptr->type        = sdatver1_1.type;
		cdatptr->id          = sdatver1_1.id;
		cdatptr->pid         = 0;
		cdatptr->dispmode    = G_STORE;
		cdatptr->mojifgcolor = sdatver1_1.mojifgcolor;
		cdatptr->mojibgcolor = sdatver1_1.mojibgcolor;
		cdatptr->mojiattr    = sdatver1_1.mojiattr;
		cdatptr->mojisize.x  = sdatver1_1.mojisizex;
		cdatptr->mojisize.y  = sdatver1_1.mojisizey;
		searchdnum2(cdatptr, &(cdatptr->r));
		posrect(&(cdatptr->r), sdatver1_1.r.p.lefttop);
		cdatptr->pnum        = sdatver1_1.pnum;
		break;
	    case 3: /* ver1.2 */
		if ((err = rea_rec(myfd, offset, (B *)&sdatver1_2,
				   sizeof(SCENEDATAver1_2),
				   NULL, NULL)) < 0) {
		    printerror(3);
		    return;
		}
		offset += sizeof(SCENEDATAver1_2);
		cdatptr->type        = sdatver1_2.type;
		cdatptr->id          = sdatver1_2.id;
		cdatptr->pid         = 0;
		cdatptr->dispmode    = sdatver1_2.dispmode;
		cdatptr->mojifgcolor = sdatver1_2.mojifgcolor;
		cdatptr->mojibgcolor = sdatver1_2.mojibgcolor;
		cdatptr->mojiattr    = sdatver1_2.mojiattr;
		cdatptr->mojisize.x  = sdatver1_2.mojisizex;
		cdatptr->mojisize.y  = sdatver1_2.mojisizey;
		searchdnum2(cdatptr, &(cdatptr->r));
		posrect(&(cdatptr->r), sdatver1_2.r.p.lefttop);
		cdatptr->pnum        = sdatver1_2.pnum;
		break;
	    case 4: /* ver1.3 */
		if ((err = rea_rec(myfd, offset, (B *)&sdatver1_3,
				   sizeof(SCENEDATAver1_3),
				   NULL, NULL)) < 0) {
		    printerror(3);
		    return;
		}
		offset += sizeof(SCENEDATAver1_3);
		cdatptr->type        = sdatver1_3.type;
		cdatptr->id          = sdatver1_3.id;
		cdatptr->pid         = 0;
		cdatptr->dispmode    = sdatver1_3.dispmode;
		cdatptr->mojifgcolor = sdatver1_3.mojifgcolor;
		cdatptr->mojibgcolor = sdatver1_3.mojibgcolor;
		cdatptr->mojiattr    = sdatver1_3.mojiattr;
		cdatptr->mojisize.x  = sdatver1_3.mojisizex;
		cdatptr->mojisize.y  = sdatver1_3.mojisizey;
		searchdnum2(cdatptr, &(cdatptr->r));
		posrect(&(cdatptr->r), sdatver1_3.r.p.lefttop);
		cdatptr->pnum        = sdatver1_3.pnum;
		break;
	    case 5: /* ver1.4 */
		if ((err = rea_rec(myfd, offset, (B *)&sdatver1_4,
				   sizeof(SCENEDATAver1_4),
				   NULL, NULL)) < 0) {
		    printerror(3);
		    return;
		}
		offset += sizeof(SCENEDATAver1_4);
		cdatptr->type        = sdatver1_4.type;
		cdatptr->id          = sdatver1_4.id;
		cdatptr->pid         = 0;
		cdatptr->dispmode    = sdatver1_4.dispmode;
		cdatptr->mojifgcolor = sdatver1_4.mojifgcolor;
		cdatptr->mojibgcolor = sdatver1_4.mojibgcolor;
		cdatptr->mojiattr    = sdatver1_4.mojiattr;
		cdatptr->mojisize.x  = sdatver1_4.mojisizex;
		cdatptr->mojisize.y  = sdatver1_4.mojisizey;
		searchdnum2(cdatptr, &(cdatptr->r));
		posrect(&(cdatptr->r), sdatver1_4.r.p.lefttop);
		cdatptr->pnum        = sdatver1_4.pnum;
		break;
	    }
	    if (i != datanum - 1) {
		cdatptr->nlnk = (CDATA *)checkmalloc(sizeof(CDATA));
		cdatptr->nlnk->plnk = cdatptr;
		cdatptr = cdatptr->nlnk;
	    }
	    else {
		cdatptr->nlnk = NULL;
	    }
	}
    }
    printf("ok.\n");
}
