#include<basic.h>
#include<btron/libapp.h>
#include<tcode.h>
#include<tstring.h>
#include<btron/dp.h>
#include<btron/vobj.h>
#include<btron/clk.h>
#include<bstdlib.h>
#include<bstring.h>
#include<btron/memory.h>

/* $B%Q%M%k$K4X$9$kDj5A(B */
#define MAXPITEM 10
#define MAXWIDTH 30

TC scr[] = { TK_S, TK_C, TK_R, TK_E, TK_E, TK_N, TNULL };

TC buf[MAXPITEM * (MAXWIDTH + 1)];

TC errormsg[][100] =
     {{ 0x3c42, 0x3954, 0x3521, 0x473d, 0x4955, 0x6435, 0x244e, 0x3847,
	0x4d2d, 0x2547, 0x213c, 0x253f, 0x242c, 0x4649, 0x2461, 0x245e,
	0x243b, 0x2473, 0x2123, 0x0000 },
      /* 0: $B<B9T5!G=IUd5$N8GM-%G!<%?$,FI$a$^$;$s!#(B */
      { 0x4955, 0x6435, 0x4c3e, 0x242c, 0x405f, 0x446a, 0x2435, 0x246c,
	0x2446, 0x2424, 0x245e, 0x243b, 0x2473, 0x2123, 0x0000 },
      /* 1: $B%a%b%j$N3MF@$K<:GT$7$^$7$?!#(B */
      { 0x2555, 0x2521, 0x2524, 0x256b, 0x242c, 0x4649, 0x2461, 0x245e,
	0x243b, 0x2473, 0x2123, 0x0000 },
      /* 2: $B%U%!%$%k$,FI$a$^$;$s!#(B*/
      { 0x2547, 0x213c, 0x253f,
	0x244e, 0x3d71, 0x242d, 0x397e, 0x245f, 0x244b, 0x3c3a, 0x4754,
	0x2437, 0x245e, 0x2437, 0x243f, 0x2123, 0x0000 },
      /* 3:$B%G!<%?$N=q$-9~$_$K<:GT$7$^$7$?!#(B */
      { 0x243d, 0x244e, 0x2526, 0x2523, 0x2573, 0x2549, 0x2526, 0x2458,
        0x244e, 0x4a23, 0x3c4c, 0x244f, 0x2447, 0x242d, 0x245e, 0x243b,
	0x2473, 0x2123, 0x0000 }
};

TC kakunin[] = { MC_STR, 0x334e, 0x4727, 0x0000 }; /* $B3NG'(B */
SWSEL msw = { MS_PARTS, { 0, 0, 70, 24 }, 0, kakunin, 0 };
PNL_ITEM pnlitem[MAXPITEM] = {
    { PARTS_ITEM, 0, { 140, 60, 0, 0 }, 0, 0, (H *)&msw }
};

PANEL errpnl = { 0x0002, 0x0048, 0, { 0, 0, 500, 116}, 1, 1, pnlitem };
PNT pnlpos = { 50, 50 };

TC versionmsg[] = {
    0x2547, 0x213c, 0x253f, 0x255c, 0x2543, 0x252f, 0x2539, 0x4550,
    0x4f3f, 0x2376, 0x2365, 0x2372, 0x2331, 0x2125, 0x2332,
    TK_NL,
    0x3a6e, 0x402e, 0x467c, 0x3b7e, 0x2121, 0x2339, 0x2336, 0x213f,
    0x2331, 0x2332, 0x213f, 0x2331, 0x2331, 0x0000 };
    /* $B%G!<%?%\%C%/%9EPO?#v#e#r#1!%#2(B */
    /* $B:n@.F|;~!!#9#6!?#1#2!?#1#1(B */

void msgpanel();

void printerror(W errno)
{
    W akey, size, err;
    TC *errmsg;

    if ((err = gettextdata(errno + 1000000, &errmsg)) < 0) {
	printf("gettextdata error %d\n", err);
	return;
    }
    msgpanel(errmsg);
    free(errmsg);
}

void msgpanel(TC *tc)
{
    W i, j, maxw, pid, itemno, sts;
    EVENT evt;
    TC    *pt, *pt2;
    DEV_SPEC ds;

    pt   = tc;
    pt2  = buf;
    maxw = 10;
    for (i = 1 ; ((i < MAXPITEM) && (pt != NULL)) ; i++) {
	pnlitem[i].itype = TEXT_ITEM;
	pnlitem[i].info  = 0;
	pnlitem[i].desc  = 0;
	pnlitem[i].dnum  = 0;
	pnlitem[i].ptr   = pt2;
	for (j = 1 ;; j++) {
	    switch (*(pt2++) = *(pt++)) {
	    case TNULL:
		pt = NULL;
		break;
	    case TK_NL:
		*(pt2 - 1) = TNULL;
		break;
	    default:
		if (i < MAXWIDTH) {
		    continue;
		}
		else {
		    *(pt2++) = TNULL;
		    break;
		}
	    }
	    break;
	}
	pnlitem[i].ir.c.left   = 30;
	pnlitem[i].ir.c.top    = 20 * i + 10;
	pnlitem[i].ir.c.right  = 30 + 16 * j;
	pnlitem[i].ir.c.bottom = 20 * i + 26;
	if (maxw < j) {
	    maxw = j;
	}
    }    
    errpnl.nitem = i;
    errpnl.r.c.right  = 40 + 16 * maxw;
    errpnl.r.c.bottom = 70 + 20 * i;

    pnlitem[0].ir.c.left = 20 + (16 * maxw - 70) / 2;
    pnlitem[0].ir.c.top  = 20 * i + 20;

    gget_spc(scr, &ds);
    pnlpos.x = (ds.hpixels - errpnl.r.c.right) / 2;
    pnlpos.y = (ds.vpixels - errpnl.r.c.bottom) / 2;
   
    pid = pcre_pnl(&errpnl, &pnlpos);
    do {
	sts = pact_pnl(pid, &evt, &itemno);
    } while (!(((sts & P_CHANGE) && (itemno == 1)) || (itemno == -1)));
    pdel_pnl(pid);
}

void printversion()
{
    msgpanel(versionmsg);
}

W setteipanelwithnbox(TC *text, W num, TC *settc, TC *canceltc)
{
    W i, j, maxw, pid, nid, itemno, sts;
    EVENT evt;
    TC    *pt, *pt2;
    DEV_SPEC ds;
    NUMBOX nbox;
    SWSEL msw1, msw2;
    PNL_ITEM setpnlitem[MAXPITEM];
    PANEL setteipnl = { 0x0002, 0x0048, 0,
			    { 0, 0, 500, 116}, 2, 1, setpnlitem };


    pt   = text;
    pt2  = buf;
    maxw = 15;
    for (i = 3 ; ((i < MAXPITEM) && (pt != NULL)) ; i++) {
	setpnlitem[i].itype = TEXT_ITEM;
	setpnlitem[i].info  = 0;
	setpnlitem[i].desc  = 0;
	setpnlitem[i].dnum  = 0;
	setpnlitem[i].ptr   = pt2;
	for (j = 1 ;; j++) {
	    switch (*(pt2++) = *(pt++)) {
	    case TNULL:
		pt = NULL;
		break;
	    case TK_NL:
		*(pt2 - 1) = TNULL;
		break;
	    default:
		if (i < MAXWIDTH) {
		    continue;
		}
		else {
		    *(pt2++) = TNULL;
		    break;
		}
	    }
	    break;
	}
	setpnlitem[i].ir.c.left   = 30;
	setpnlitem[i].ir.c.top    = 20 * i - 30;
	setpnlitem[i].ir.c.right  = 30 + 16 * j;
	setpnlitem[i].ir.c.bottom = 20 * i - 14;
	if (maxw < j) {
	    maxw = j;
	}
    }

    setteipnl.oframe = 0x0002;
    setteipnl.iframe = 0x0048;
    setteipnl.bgpat = 0;
/*    setteipnl.nitem = i + 1;*/
    setteipnl.nitem = i;
    setteipnl.defsw = 2;
    setteipnl.r.c.right  = 40 + 16 * maxw;
    setteipnl.r.c.bottom = 80 + 20 * i;

    nbox.type = NB_PARTS;
    setrect(nbox.r, 0, 0, maxw * 16 - 20, 24); 
    nbox.fmt = 0x1000;
    nbox.cv.l = num;
    
    setpnlitem[2].itype = PARTS_ITEM;
    setpnlitem[2].info  = 0;
    setpnlitem[2].desc  = 0;
    setpnlitem[2].dnum  = 0;
    setpnlitem[2].ptr   = (H *)&nbox;
    setpnlitem[2].ir.c.left = 30;
    setpnlitem[2].ir.c.top  = 20 * i - 20; 


    msw1.type = MS_PARTS;
    setrect(msw1.r, 0, 0, 100, 24);
    msw1.name = canceltc;
    
    setpnlitem[0].itype = PARTS_ITEM;
    setpnlitem[0].info  = 0;
    setpnlitem[0].desc  = 0;
    setpnlitem[0].dnum  = 0;
    setpnlitem[0].ptr   = (H *)&msw1;
    setpnlitem[0].ir.c.left = 40;
    setpnlitem[0].ir.c.top  = 20 * i + 20;

    msw2.type = MS_PARTS;
    setrect(msw2.r, 0, 0, 100, 24);
    msw2.name = settc;
    
    setpnlitem[1].itype = PARTS_ITEM;
    setpnlitem[1].info  = 0;
    setpnlitem[1].desc  = 0;
    setpnlitem[1].dnum  = 0;
    setpnlitem[1].ptr   = (H *)&msw2;
    setpnlitem[1].ir.c.left = 16 * maxw - 100;
    setpnlitem[1].ir.c.top  = 20 * i + 20;

    gget_spc(scr, &ds);
    pnlpos.x = (ds.hpixels - setteipnl.r.c.right) / 2;
    pnlpos.y = (ds.vpixels - setteipnl.r.c.bottom) / 2;
    pid = pcre_pnl(&setteipnl, &pnlpos);
    if (pid < 0) {
	printf("panel create error %d\n", pid);
	return -1;
    }
    do {
	sts = pact_pnl(pid, &evt, &itemno);
    } while (!(((sts & P_CHANGE) && ((itemno == 1)
				     || (itemno == 2))) || (itemno == -2)));
    if (itemno == 1) {
	itemno = -1;
    }
    else {
	nid = pget_itm(pid, 3, NULL);
	cget_val(nid, 2, &itemno);
    }
    pdel_pnl(pid);
    return itemno;
}


W setteipanelwithtbox(TC *text, TC *tboxtc, TC *settc, TC *canceltc)
{
    W i, j, maxw, pid, itemno, sts;
    EVENT evt;
    TC    *pt, *pt2;
    DEV_SPEC ds;
    TEXTBOX tbox;
    SWSEL msw1, msw2;
    PNL_ITEM setpnlitem[MAXPITEM];
    PANEL setteipnl = { 0x0002, 0x0048, 0,
			    { 0, 0, 500, 116}, 2, 2, setpnlitem };
    pt   = text;
    pt2  = buf;
    maxw = 15;
    for (i = 3 ; ((i < MAXPITEM) && (pt != NULL)) ; i++) {
	setpnlitem[i].itype = TEXT_ITEM;
	setpnlitem[i].info  = 0;
	setpnlitem[i].desc  = 0;
	setpnlitem[i].dnum  = 0;
	setpnlitem[i].ptr   = pt2;
	for (j = 1 ;; j++) {
	    switch (*(pt2++) = *(pt++)) {
	    case TNULL:
		pt = NULL;
		break;
	    case TK_NL:
		*(pt2 - 1) = TNULL;
		break;
	    default:
		if (i < MAXWIDTH) {
		    continue;
		}
		else {
		    *(pt2++) = TNULL;
		    break;
		}
	    }
	    break;
	}
	setpnlitem[i].ir.c.left   = 30;
	setpnlitem[i].ir.c.top    = 20 * i - 30;
	setpnlitem[i].ir.c.right  = 30 + 16 * j;
	setpnlitem[i].ir.c.bottom = 20 * i - 14;
	if (maxw < j) {
	    maxw = j;
	}
    }

    setteipnl.oframe = 0x0002;
    setteipnl.iframe = 0x0048;
    setteipnl.bgpat = 0;
    setteipnl.nitem = i;
    setteipnl.defsw = 2;
    setteipnl.r.c.right  = 40 + 16 * maxw;
    setteipnl.r.c.bottom = 80 + 20 * i;

    tbox.type = TB_PARTS;
    setrect(tbox.r, 0, 0, maxw * 16 - 20, 24); 
    tbox.txsize = 50;
    tbox.text = tboxtc;
    
    setpnlitem[2].itype = PARTS_ITEM;
    setpnlitem[2].info  = 0;
    setpnlitem[2].desc  = 0;
    setpnlitem[2].dnum  = 0;
    setpnlitem[2].ptr   = (H *)&tbox;
    setpnlitem[2].ir.c.left = 30;
    setpnlitem[2].ir.c.top  = 20 * i - 20; 


    msw1.type = MS_PARTS;
    setrect(msw1.r, 0, 0, 100, 24);
    msw1.name = canceltc;
    
    setpnlitem[0].itype = PARTS_ITEM;
    setpnlitem[0].info  = 0;
    setpnlitem[0].desc  = 0;
    setpnlitem[0].dnum  = 0;
    setpnlitem[0].ptr   = (H *)&msw1;
    setpnlitem[0].ir.c.left = 40;
    setpnlitem[0].ir.c.top  = 20 * i + 20;

    msw2.type = MS_PARTS;
    setrect(msw2.r, 0, 0, 100, 24);
    msw2.name = settc;
    
    setpnlitem[1].itype = PARTS_ITEM;
    setpnlitem[1].info  = 0;
    setpnlitem[1].desc  = 0;
    setpnlitem[1].dnum  = 0;
    setpnlitem[1].ptr   = (H *)&msw2;
    setpnlitem[1].ir.c.left = 16 * maxw - 100;
    setpnlitem[1].ir.c.top  = 20 * i + 20;

    gget_spc(scr, &ds);
    pnlpos.x = (ds.hpixels - setteipnl.r.c.right) / 2;
    pnlpos.y = (ds.vpixels - setteipnl.r.c.bottom) / 2;
   
    pid = pcre_pnl(&setteipnl, &pnlpos);

    if (pid < 0) {
	printf("panel create error %d\n", pid);
	return -1;
    }
    do {
	sts = pact_pnl(pid, &evt, &itemno);
    } while (!(((sts & P_CHANGE) && ((itemno == 1)
				     || (itemno == 2))) || (itemno == -2)));
    cget_val(pget_itm(pid, 3, NULL), 64, (W *)tboxtc);
    pdel_pnl(pid);
    return (itemno == 1) ? 0 : 1;
}
