#include "databox.h"
#include "scene.h"

H swapH(H i);
W swapW(W i);

/* $B%G!<%?%\%C%/%9%G!<%?$NJ]B8(B */
void savedatabox(W bwid)
{
    DBOX_HDR headder;
    DTYP_INX typindex;
    DNUM_INX numindex;
    CBMP     *cbmp, *cbmp2;
    BMP      *bmp2;
    W i, j, k, l, err, offset, num, soffset, size, size2, size3, size4,
      tmp, motooffset, tcsize;
    
    PAT	      *patdat, patdat2;
    
    TF_RECT     *tfrect; 
    TF_POLYGON  *tfpolygon; 
    TF_POLYLINE *tfpolyline;
    H		*tf2, *tf3;
   
    PARTSDATA *pdat;
   

    W koffset, recordtype;
    TC *tmpptr, *tmpptr2;
    B  *tmpbaseaddr[10];
    MENUDATA  *mdat;

    GMENUDATA *gmdat;
    PANELDATA *pnldat;

    TEXTBOX tbox2;
    NUMBOX  nbox2;
    SERBOX  sbox2;
    SWSEL   swsel2;
    PICTSW  picsw2;
    VOLUME  vol2;

    MENUDISP *mdisp2;
    MENUITEM mitem2;
    GMENU    gmenu2;
    PANEL    panel2;
    PNL_ITEM pnlitem2[256];

    /* $BFbIt>pJs$r(B0$B$K$7$J$$$H(Bbright/V$B$N(BOS$B$,Mn$A$k!#0lBN2?8N(B??????? */
    numindex.info[0] = numindex.info[1] = 0;
    num = 0;
    soffset = sizeof(DBOX_HDR);
    for (i = 1 ; i <= 10 ; i++) {
	if (datanum[i]) {
	    num++;
	    soffset += sizeof(DTYP_INX) +
		sizeof(DNUM_INX) * (datanum[i] - 1);
	}
    }
    
    headder.ntyp = swapH(num);
    headder.ixsize = swapH(soffset);

    recordtype = (changeendian) ? 30 : 10;
    err = fnd_rec(myfd, F_TOPEND, 1 << recordtype, (UH)NULL, NULL);
    if (err == recordtype) {
	del_rec(myfd);
    }
    if ((err = apd_rec(myfd, (B *)&headder,
		       sizeof(DBOX_HDR), recordtype, 0, (UH)NULL)) < 0) {
	printerror(3);
	return;
    }
    if ((err = fnd_rec(myfd, F_TOPEND, 1 << recordtype, (UH)NULL, NULL)) !=
	recordtype) {
	printerror(2);
	return;
    }
    if ((err = wri_rec(myfd, -1, NULL,
	 soffset - sizeof(DBOX_HDR), NULL, NULL, (UH)NULL)) < 0) {
	printerror(3);
	return;
    }

    offset = sizeof(DBOX_HDR);
    
    for (i = 1 ; i <= 10 ; i++) {
	if (datanum[i]) {
 	    set_window_bar(bwid, i - 1, 10);
printf("saving type %d data * %d", i, datanum[i]);	    
	    typindex.npos = swapW(offset + sizeof(DTYP_INX) +
		sizeof(DNUM_INX) * (datanum[i] - 1));
	    typindex.typ  = swapW(i);
	    typindex.attr = swapW(1);
	    typindex.nd   = swapW(datanum[i]);
	    if ((err = wri_rec(myfd, offset, (B *)&typindex,
			       sizeof(DTYP_INX) - sizeof(DNUM_INX),
			       NULL, NULL, (UH)NULL)) < 0) {
		printerror(3);			
		return;
	    }
	    offset += sizeof(DTYP_INX) - sizeof(DNUM_INX);
	    
	    for(j = 0 ; j < datanum[i] ; j++) {
		numindex.id = swapW(data[i][j].id);
		numindex.pos = swapW(soffset);

		switch (i) {
		case PTR_DATA:
		    /* $B%(%s%G%#%"%sJQ49$bL$%5%]!<%H(B */
		    numindex.size = sizeof(PTRDATA);
		    if ((err = wri_rec(myfd, soffset, data[i][j].ptr,
				       numindex.size, NULL, NULL,
				       (UH)NULL)) < 0) {
			printerror(3);
			return;
		    }
		    soffset += numindex.size;
		    break;
		case PAT_DATA:
		    patdat = (PAT *)(data[i][j].ptr);
		    if (patdat->spat.kind == 0) {
			patdat2.spat.kind = swapH(patdat->spat.kind);
			patdat2.spat.hsize = swapH(patdat->spat.hsize);
			patdat2.spat.vsize = swapH(patdat->spat.vsize);
			patdat2.spat.fgcol = swapW(patdat->spat.fgcol);
			patdat2.spat.bgcol = swapW(patdat->spat.bgcol);
			size = sizeof(PatKind) + sizeof(UH) * 2 +
			    sizeof(COLOR) * 2 + sizeof(UB *);
			size2 = ((patdat->spat.hsize + 15) / 16) * 2 *
			    patdat->spat.vsize;
			tmpptr = (TC *)patdat->spat.mask;
			patdat->spat.mask = (B *)size;
			patdat2.spat.mask = (B *)swapW((W)patdat->spat.mask);
			if ((err = wri_rec(myfd, soffset, (B *)&patdat2,
					   size, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
                        patdat->spat.mask = (B *)tmpptr;
			soffset += size;
			if ((err = wri_rec(myfd, soffset, patdat->spat.mask,
					   size2, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
			soffset += size2;
			patdat->spat.mask = (B *)tmpptr;
			numindex.size = size + size2;
		    }
		    else {
			patdat2.mpat.kind = swapH(patdat->mpat.kind);
			patdat2.mpat.hsize = swapH(patdat->mpat.hsize);
			patdat2.mpat.vsize = swapH(patdat->mpat.vsize);
			size = sizeof(PatKind) + sizeof(UH) * 2 +
			    sizeof(UB *) + sizeof(BMP *);
			tmpptr  = (TC *)patdat->mpat.mask;
			tmpptr2 = (TC *)patdat->mpat.bmap;
			patdat->mpat.mask = (B *)size;
                        size3 = ((patdat->spat.hsize + 15) / 16) * 2 *
			    patdat->spat.vsize;
			patdat->mpat.bmap = (BMP *)(size + size3);
			patdat2.mpat.mask = (B *)swapW((W)patdat->mpat.mask);
			patdat2.mpat.bmap = (BMP *)swapW((W)patdat->mpat.bmap);
			if ((err = wri_rec(myfd, soffset, (B *)&patdat2,
					   size, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
			soffset += size;

                        patdat->mpat.mask = (B *)tmpptr;
                        patdat->mpat.bmap = (BMP *)tmpptr2;

                        if (!patdat->mpat.mask) {
			    patdat->mpat.mask = malloc(size3);
			    for (k = 0 ; k < size3 ; k++) {
				patdat->mpat.mask[k] = 0xff;
			    }
			    /* $B%^%9%/$,@_Dj$5$l$?$N$G%^%9%/@_Dj%\%?%s$r(B
			       inact$B$K$9$k!#(B */
			    display(2);
			}
			if ((err = wri_rec(myfd, soffset,
					   (B *)patdat->mpat.mask,
					   size3, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
                        soffset += size3;

			size2 = patdat->mpat.bmap->rowbytes *
			    (patdat->mpat.bmap->bounds.c.bottom -
			     patdat->mpat.bmap->bounds.c.top);
			size4 = sizeof(BMP) +
			    (patdat->mpat.bmap->planes - 1) * sizeof(UB *);
			bmp2 = (BMP *)malloc(size4);
			bmp2->planes = swapW(patdat->mpat.bmap->planes);
			bmp2->pixbits = swapH(patdat->mpat.bmap->pixbits);
			bmp2->rowbytes = swapH(patdat->mpat.bmap->rowbytes);
			bmp2->bounds.c.left =
			    swapH(patdat->mpat.bmap->bounds.c.left);
			bmp2->bounds.c.top =
			    swapH(patdat->mpat.bmap->bounds.c.top);
			bmp2->bounds.c.right =
			    swapH(patdat->mpat.bmap->bounds.c.right);
			bmp2->bounds.c.bottom =
			    swapH(patdat->mpat.bmap->bounds.c.bottom);
			for (k = 0 ; k < patdat->mpat.bmap->planes ; k++) {
			    tmpbaseaddr[k] = patdat->mpat.bmap->baseaddr[k];
			    patdat->mpat.bmap->baseaddr[k] =
				(B *)(size + size3 + sizeof(BMP) +
				      (patdat->mpat.bmap->planes - 1) *
				      sizeof(UB *) + k * size2);
			    bmp2->baseaddr[k] =
				(B *)swapW((W)patdat->mpat.bmap->baseaddr[k]);
			}
			if ((err = wri_rec(myfd, soffset,
					   (B *)bmp2,
					   size4, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
			if ((err = wri_rec(myfd, soffset + size4,
				   ((B *)(patdat->mpat.bmap)) + size4,
				   data[i][j].length - size4, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
			free(bmp2);
			for (k = 0 ; k < patdat->mpat.bmap->planes ; k++) {
			    patdat->mpat.bmap->baseaddr[k] = tmpbaseaddr[k];
			}
			soffset += data[i][j].length;
			numindex.size = size + data[i][j].length + size3;
		    }
		    break;
		case PICT_DATA:
		case BMAP_DATA: /* $B%S%C%H%^%C%W%G!<%?(B */
		    numindex.size = data[i][j].length;
		    cbmp = (CBMP *)(data[i][j].ptr);
		    size2 = sizeof(CBMP) +
			(cbmp->bmp.planes - 1) * sizeof(UB *);
		    cbmp2 = (CBMP *)malloc(size2);
		    cbmp2->compac = swapW(cbmp->compac);
		    cbmp2->bmp.planes = swapW(cbmp->bmp.planes);
		    cbmp2->bmp.pixbits = swapH(cbmp->bmp.pixbits);
		    cbmp2->bmp.rowbytes = swapH(cbmp->bmp.rowbytes);
		    cbmp2->bmp.bounds.c.left =
			swapH(cbmp->bmp.bounds.c.left);
		    cbmp2->bmp.bounds.c.top =
			swapH(cbmp->bmp.bounds.c.top);
		    cbmp2->bmp.bounds.c.right =
			swapH(cbmp->bmp.bounds.c.right);
		    cbmp2->bmp.bounds.c.bottom =
			swapH(cbmp->bmp.bounds.c.bottom);
		    size = cbmp->bmp.rowbytes * (cbmp->bmp.bounds.c.bottom -
						 cbmp->bmp.bounds.c.top);
		    for (k = 0 ; k < cbmp->bmp.planes ; k++) {
			tmpbaseaddr[k] = cbmp->bmp.baseaddr[k];
			cbmp->bmp.baseaddr[k] =
			    (B *)(sizeof(CBMP) + (cbmp->bmp.planes - 1) *
				  sizeof(UB *) + k * size);
			cbmp2->bmp.baseaddr[k] =
			    (B *)swapW((W)cbmp->bmp.baseaddr[k]);
		    }
		    if ((err = wri_rec(myfd, soffset, (B *)cbmp2,
				       size2, NULL, NULL,
				       (UH)NULL)) < 0) {
			printerror(3);
			return;
		    }
		    if ((err = wri_rec(myfd, soffset + size2,
				       data[i][j].ptr + size2,
				       numindex.size - size2, NULL, NULL,
				       (UH)NULL)) < 0) {
			printerror(3);
			return;
		    }
		    free(cbmp2);
		    for (k = 0 ; k < cbmp->bmp.planes ; k++) {
			cbmp->bmp.baseaddr[k] = tmpbaseaddr[k];
		    }
		    soffset += numindex.size;
		    break;
		case FIG_DATA:
		    tfrect     = (TF_RECT *)(data[i][j].ptr);
		    tfpolygon  = (TF_POLYGON *)(data[i][j].ptr);
		    tfpolyline = (TF_POLYLINE *)(data[i][j].ptr);
		    switch (tfrect->subid) {
		    case TF_RECT_SID:
			numindex.size = sizeof(TF_RECT);
			break;
		    case TF_RRECT_SID:
			numindex.size = sizeof(TF_RRECT);
			break;
		    case TF_OVAL_SID:
			numindex.size = sizeof(TF_OVAL);
			break;
		    case TF_SEC_SID:
			numindex.size = sizeof(TF_SEC);
			break;
		    case TF_CHORD_SID:
			numindex.size = sizeof(TF_CHORD);
			break;
		    case TF_POLYGON_SID:
			numindex.size = sizeof(TF_POLYGON) +
			    (tfpolygon->np - 1) * sizeof(PNT);
			break;
		    case TF_LINE_SID:
			numindex.size = sizeof(TF_LINE);
			break;
		    case TF_ARC_SID:
			numindex.size = sizeof(TF_ARC);
			break;
		    case TF_POLYLINE_SID:
			numindex.size = sizeof(TF_POLYLINE) +
			    (tfpolyline->np - 1) * sizeof(PNT);
			break;
		    }
		    if (changeendian) {
			tf2 = (H *)malloc(numindex.size);
			tf3 = (H *)data[i][j].ptr;
			for (l = 0 ; l < numindex.size / sizeof(H) ; l++) {
			    tf2[l] = swapH(tf3[l]);
			}
			if ((err = wri_rec(myfd, soffset, (B *)tf2,
					   numindex.size, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
			free(tf2);
		    }
		    else {
			if ((err = wri_rec(myfd, soffset, data[i][j].ptr,
					   numindex.size, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
		    }
		    soffset += numindex.size;		    
		    break;
		case TEXT_DATA: /* $BJ8;zNs%G!<%?(B */
		    numindex.size = data[i][j].length;
		    if (changeendian) {
			tf2 = (H *)malloc(numindex.size);
			tf3 = (H *)data[i][j].ptr;
			for (l = 0 ; l < numindex.size / sizeof(H) ; l++) {
			    tf2[l] = swapH(tf3[l]);
			}
			if ((err = wri_rec(myfd, soffset, (B *)tf2,
					   numindex.size, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
			free(tf2);
		    }
		    else {
			if ((err = wri_rec(myfd, soffset, data[i][j].ptr,
					   numindex.size, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
		    }
		    soffset += numindex.size;
		    break;
		case PARTS_DATA:
		    pdat = (PARTSDATA *)(data[i][j].ptr);
		    switch (pdat->parts.tb.type & 0x1f) {
		    case TB_PARTS:
		    case XB_PARTS:
			size = sizeof(TEXTBOX) -
			    ((pdat->parts.tb.type & P_PARTDISP) ?
			     0 : sizeof(PARTDISP));
			tmpptr = pdat->parts.tb.text;
			pdat->parts.tb.text = (TC *)size;
			tbox2.type = swapW(pdat->parts.tb.type);
			tbox2.r.c.left =
			    swapH(pdat->parts.tb.r.c.left);
			tbox2.r.c.top =
			    swapH(pdat->parts.tb.r.c.top);
			tbox2.r.c.right =
			    swapH(pdat->parts.tb.r.c.right);
			tbox2.r.c.bottom =
			    swapH(pdat->parts.tb.r.c.bottom);
			tbox2.txsize = swapW(pdat->parts.tb.txsize);
			tbox2.text = (TC *)swapW((W)pdat->parts.tb.text);
			tbox2.atr.frpat =
			    swapW(pdat->parts.tb.atr.frpat);
			tbox2.atr.bgpat =
			    swapW(pdat->parts.tb.atr.bgpat);
			tbox2.atr.chcol =
			    swapW(pdat->parts.tb.atr.chcol);
			tbox2.atr.misc =
			    swapW(pdat->parts.tb.atr.misc);
			if ((err = wri_rec(myfd, soffset,
					   (B *)&tbox2,
					   size, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
			soffset += size;
			tcsize = pdat->ptrlen;
			if (changeendian) {
			    tf2 = (H *)malloc(tcsize);
			    tf3 = (H *)tmpptr;
			    for (l = 0 ; l < tcsize / sizeof(H) ; l++) {
				tf2[l] = swapH(tf3[l]);
			    }
			    if ((err = wri_rec(myfd, soffset, (B *)tf2,
					       tcsize, NULL, NULL,
					       (UH)NULL)) < 0) {
				printerror(3);
				return;
			    }
			    free(tf2);
			}
			else {
			    if ((err = wri_rec(myfd, soffset,
					       (B *)tmpptr,
					       tcsize, NULL, NULL,
					       (UH)NULL)) < 0) {
				printerror(3);
				return;
			    }
			}
			soffset += tcsize;
			pdat->parts.tb.text = tmpptr;
			numindex.size = size + tcsize;
			break;
		    case NB_PARTS:
			size = sizeof(NUMBOX) -
			    ((pdat->parts.tb.type & P_PARTDISP) ?
			     0 : sizeof(PARTDISP));
			nbox2.type = swapW(pdat->parts.nb.type);
			nbox2.r.c.left =
			    swapH(pdat->parts.nb.r.c.left);
			nbox2.r.c.top =
			    swapH(pdat->parts.nb.r.c.top);
			nbox2.r.c.right =
			    swapH(pdat->parts.nb.r.c.right);
			nbox2.r.c.bottom =
			    swapH(pdat->parts.nb.r.c.bottom);
			nbox2.fmt = swapW(pdat->parts.nb.fmt);
			/* long $B$OL$%5%]!<%H(B */
			nbox2.cv.l = swapW(pdat->parts.nb.cv.l);
			nbox2.atr.frpat =
			    swapW(pdat->parts.nb.atr.frpat);
			nbox2.atr.bgpat =
			    swapW(pdat->parts.nb.atr.bgpat);
			nbox2.atr.chcol =
			    swapW(pdat->parts.nb.atr.chcol);
			nbox2.atr.misc =
			    swapW(pdat->parts.nb.atr.misc);
			if ((err = wri_rec(myfd, soffset,
					   (B *)&nbox2,
					   size, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
			soffset += size;
			numindex.size = size;
			break;
		    case SB_PARTS:
			size = sizeof(SERBOX) -
			    ((pdat->parts.sb.type & P_PARTDISP) ?
			     0 : sizeof(PARTDISP));
			tmpptr = (TC *)pdat->parts.sb.cv;
			pdat->parts.sb.cv = (W *)size;
			size2 = sizeof(W) * pdat->parts.sb.nfld;
			tmpptr2 = pdat->parts.sb.fmt;
			pdat->parts.sb.fmt = (TC *)(size + size2);
			sbox2.type = swapW(pdat->parts.tb.type);
			sbox2.r.c.left =
			    swapH(pdat->parts.sb.r.c.left);
			sbox2.r.c.top =
			    swapH(pdat->parts.sb.r.c.top);
			sbox2.r.c.right =
			    swapH(pdat->parts.sb.r.c.right);
			sbox2.r.c.bottom =
			    swapH(pdat->parts.sb.r.c.bottom);
			sbox2.fmt = (TC *)swapW((W)pdat->parts.sb.fmt);
			sbox2.nfld = swapW(pdat->parts.sb.nfld);
			sbox2.cv = (W *)swapW((W)pdat->parts.sb.cv);
			sbox2.atr.frpat =
			    swapW(pdat->parts.sb.atr.frpat);
			sbox2.atr.bgpat =
			    swapW(pdat->parts.sb.atr.bgpat);
			sbox2.atr.chcol =
			    swapW(pdat->parts.sb.atr.chcol);
			sbox2.atr.misc =
			    swapW(pdat->parts.sb.atr.misc);
			if ((err = wri_rec(myfd, soffset,
					   (B *)&sbox2,
					   size, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}

			soffset += size;
			if (changeendian) {
			    tf2 = (H *)malloc(size2);
			    tf3 = (H *)tmpptr;
			    for (l = 0 ; l < size2 / sizeof(H) ; l++) {
				tf2[l] = swapH(tf3[l]);
			    }
			    if ((err = wri_rec(myfd, soffset, (B *)tf2,
					       size2, NULL, NULL,
					       (UH)NULL)) < 0) {
				printerror(3);
				return;
			    }
			    free(tf2);
			}
			else {
			    if ((err = wri_rec(myfd, soffset,
					       (B *)tmpptr,
					       size2, NULL, NULL,
					       (UH)NULL)) < 0) {
				printerror(3);
				return;
			    }
			}
			soffset += size2;
			
			tcsize = pdat->ptrlen;
			if (changeendian) {
			    tf2 = (H *)malloc(tcsize);
			    tf3 = (H *)tmpptr2;
			    for (l = 0 ; l < tcsize / sizeof(H) ; l++) {
				tf2[l] = swapH(tf3[l]);
			    }
			    if ((err = wri_rec(myfd, soffset, (B *)tf2,
					       tcsize, NULL, NULL,
					       (UH)NULL)) < 0) {
				printerror(3);
				return;
			    }
			    free(tf2);
			}
			else {
			    if ((err = wri_rec(myfd, soffset,
					       (B *)tmpptr2,
					       tcsize, NULL, NULL,
					       (UH)NULL)) < 0) {
				printerror(3);
				return;
			    }
			}
			soffset += tcsize;
			pdat->parts.sb.cv  = (W *)tmpptr;
			pdat->parts.sb.fmt = tmpptr2;
			numindex.size = size + size2 + tcsize;
			break;
		    case AS_PARTS:
		    case MS_PARTS:
		    case WS_PARTS:
		    case SS_PARTS:
			size = sizeof(SWSEL) -
			    ((pdat->parts.ss.type & P_PARTDISP) ?
			     0 : sizeof(PARTDISP));
			tmpptr = pdat->parts.ss.name;
			pdat->parts.ss.name = (TC *)size;
			swsel2.type = swapW(pdat->parts.ss.type);
			swsel2.r.c.left =
			    swapH(pdat->parts.ss.r.c.left);
			swsel2.r.c.top =
			    swapH(pdat->parts.ss.r.c.top);
			swsel2.r.c.right =
			    swapH(pdat->parts.ss.r.c.right);
			swsel2.r.c.bottom =
			    swapH(pdat->parts.ss.r.c.bottom);
			swsel2.cv = swapW(pdat->parts.ss.cv);
			swsel2.name = (TC *)swapW((W)pdat->parts.ss.name);
			swsel2.atr.frpat =
			    swapW(pdat->parts.ss.atr.frpat);
			swsel2.atr.bgpat =
			    swapW(pdat->parts.ss.atr.bgpat);
			swsel2.atr.chcol =
			    swapW(pdat->parts.ss.atr.chcol);
			swsel2.atr.misc =
			    swapW(pdat->parts.ss.atr.misc);
			if ((err = wri_rec(myfd, soffset,
					   (B *)&swsel2,
					   size, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
			soffset += size;
			tcsize = pdat->ptrlen;
			if (changeendian) {
			    tf2 = (H *)malloc(tcsize);
			    tf3 = (H *)tmpptr;
			    for (l = 0 ; l < tcsize / sizeof(H) ; l++) {
				tf2[l] = swapH(tf3[l]);
			    }
			    if ((err = wri_rec(myfd, soffset, (B *)tf2,
					       tcsize, NULL, NULL,
					       (UH)NULL)) < 0) {
				printerror(3);
				return;
			    }
			    free(tf2);
			}
			else {
			    if ((err = wri_rec(myfd, soffset,
					       (B *)tmpptr,
					       tcsize, NULL, NULL,
					       (UH)NULL)) < 0) {
				printerror(3);
				return;
			    }
			}
			soffset += tcsize;
			pdat->parts.ss.name = tmpptr;
			numindex.size = size + tcsize;
			break;
		    case PA_PARTS:
		    case PM_PARTS:
			size = sizeof(PICTSW) -
			    ((pdat->parts.pw.type & P_PARTDISP) ?
			     0 : sizeof(PARTDISP));
			picsw2.type = swapW(pdat->parts.pw.type);
			picsw2.r.c.left =
			    swapH(pdat->parts.pw.r.c.left);
			picsw2.r.c.top =
			    swapH(pdat->parts.pw.r.c.top);
			picsw2.r.c.right =
			    swapH(pdat->parts.pw.r.c.right);
			picsw2.r.c.bottom =
			    swapH(pdat->parts.pw.r.c.bottom);
			picsw2.cv = swapW(pdat->parts.pw.cv);
			picsw2.onpat = swapW(pdat->parts.pw.onpat);
			picsw2.offpat = swapW(pdat->parts.pw.offpat);
			picsw2.atr.frpat =
			    swapW(pdat->parts.pw.atr.frpat);
			picsw2.atr.bgpat =
			    swapW(pdat->parts.pw.atr.bgpat);
			picsw2.atr.chcol =
			    swapW(pdat->parts.pw.atr.chcol);
			picsw2.atr.misc =
			    swapW(pdat->parts.pw.atr.misc);
			if ((err = wri_rec(myfd, soffset,
					   (B *)&picsw2,
					   size, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
			soffset += size;
			numindex.size = size;
			break;
		    case VL_PARTS:
			size = sizeof(VOLUME) -
			    ((pdat->parts.vl.type & P_PARTDISP) ?
			     0 : sizeof(PARTDISP));
			vol2.type = swapW(pdat->parts.vl.type);
			vol2.r.c.left =
			    swapH(pdat->parts.vl.r.c.left);
			vol2.r.c.top =
			    swapH(pdat->parts.vl.r.c.top);
			vol2.r.c.right =
			    swapH(pdat->parts.vl.r.c.right);
			vol2.r.c.bottom =
			    swapH(pdat->parts.vl.r.c.bottom);
			vol2.clo = swapW(pdat->parts.vl.clo);
			vol2.chi = swapW(pdat->parts.vl.chi);
			vol2.lo = swapW(pdat->parts.vl.lo);
			vol2.hi = swapW(pdat->parts.vl.hi);
			vol2.patnum = swapW(pdat->parts.vl.patnum);
			vol2.atr.frpat =
			    swapW(pdat->parts.vl.atr.frpat);
			vol2.atr.bgpat =
			    swapW(pdat->parts.vl.atr.bgpat);
			vol2.atr.chcol =
			    swapW(pdat->parts.vl.atr.chcol);
			vol2.atr.misc =
			    swapW(pdat->parts.vl.atr.misc);
			if ((err = wri_rec(myfd, soffset,
					   (B *)&vol2,
					   size, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
			soffset += size;
			numindex.size = size;
			break;
		    }
		    break;
		case MENU_DATA:
		    motooffset = soffset;
		    mdat = (MENUDATA *)(data[i][j].ptr);
		    tmp = swapW(mdat->nitem + mdat->menudisp * 0x8000);
		    if ((err = wri_rec(myfd, soffset, (B *)&tmp,
				       sizeof(W), NULL, NULL,
				       (UH)NULL)) < 0) {
			printerror(3);
			return;
		    }
		    soffset += sizeof(W);
		    if (mdat->menudisp) {
			mdisp2 = malloc(sizeof(MENUDISP) + sizeof(W) * 2);
			mdisp2->m_frame = swapW(mdat->mdisp.m_frame);
			mdisp2->s_frame = swapW(mdat->mdisp.s_frame);
			mdisp2->m_bgpat = swapW(mdat->mdisp.m_bgpat);
			mdisp2->s_bgpat = swapW(mdat->mdisp.s_bgpat);
			mdisp2->s_indpat = swapW(mdat->mdisp.s_indpat);
			mdisp2->m_chcol = swapW(mdat->mdisp.m_chcol);
			mdisp2->s_chcol = swapW(mdat->mdisp.s_chcol);
			mdisp2->s_keycol = swapW(mdat->mdisp.s_keycol);
			if ((err = wri_rec(myfd, soffset,
					   (B *)mdisp2,
					   sizeof(MENUDISP) + sizeof(W) * 2,
					   NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
			free(mdisp2);
			soffset += sizeof(MENUDISP) + sizeof(W) * 2;
		    }

		    koffset = soffset + sizeof(MENUITEM) * mdat->nitem;
		    /* $B$"$i$+$8$a%l%3!<%I$N%5%$%:$rBg$-$/$7$F$*$/(B */
		    if ((err = wri_rec(myfd, soffset, NULL,
				       koffset - soffset, NULL, NULL,
				       (UH)NULL)) < 0) {
			printerror(3);
			return;
		    }
		    for (k = 0 ; k < mdat->nitem ; k++) {
			/* $BJQ99$5$l$?$H$-$N$3$H$r9M$($F%G!<%?%\%C%/%9$N$O(B
			   $BL$%5%]!<%H(B */ 
			mdat->mitem[k].dnum = 0;
			size = mdat->ptrlen[k];
			if (changeendian) {
			    tf2 = (H *)malloc(size);
			    tf3 = (H *)mdat->mitem[k].ptr;
			    for (l = 0 ; l < size / sizeof(H) ; l++) {
				tf2[l] = swapH(tf3[l]);
			    }
			    if ((err = wri_rec(myfd, koffset, (B *)tf2,
					       size, NULL, NULL,
					       (UH)NULL)) < 0) {
				printerror(3);
				return;
			    }
			    free(tf2);
			}
			else {
			    if ((err = wri_rec(myfd, koffset,
					       (B *)(mdat->mitem[k].ptr),
					       size, NULL, NULL,
					       (UH)NULL)) < 0) {
				printerror(3);
				return;
			    }
			}			
			tmpptr = mdat->mitem[k].ptr;
			mdat->mitem[k].ptr = (TC *)(koffset - motooffset);
			mitem2.inact = swapW(mdat->mitem[k].inact);
			mitem2.select = swapW(mdat->mitem[k].select);
			mitem2.desc = swapW(mdat->mitem[k].desc);
			mitem2.dnum = swapW(mdat->mitem[k].dnum);
			mitem2.ptr = (TC *)swapW((W)mdat->mitem[k].ptr);
			if ((err = wri_rec(myfd, soffset,
					   (B *)&mitem2,
					   sizeof(MENUITEM), NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    mdat->mitem[k].ptr = tmpptr;
			    return;
			}
			mdat->mitem[k].ptr = tmpptr;			
			soffset += sizeof(MENUITEM);
			koffset += size;
		    }
		    soffset = koffset;
		    numindex.size = soffset - motooffset;
		    break;
		case GMENU_DATA:
		    gmdat = (GMENUDATA *)(data[i][j].ptr);
		    size = sizeof(GMENU) + (gmdat->gmenu.nitem - 32) *
			sizeof(RECT);
		    gmenu2.frame = swapW(gmdat->gmenu.frame);
		    gmenu2.bgpat = swapW(gmdat->gmenu.bgpat);
		    gmenu2.indpat = swapW(gmdat->gmenu.indpat);
		    gmenu2.chcol = swapW(gmdat->gmenu.chcol);
		    gmenu2.area.c.left = swapH(gmdat->gmenu.area.c.left);
		    gmenu2.area.c.top = swapH(gmdat->gmenu.area.c.top);
		    gmenu2.area.c.right = swapH(gmdat->gmenu.area.c.right);
		    gmenu2.area.c.bottom = swapH(gmdat->gmenu.area.c.bottom);
		    gmenu2.inact = swapW(gmdat->gmenu.inact);
		    gmenu2.select = swapW(gmdat->gmenu.select);
		    gmenu2.desc = swapW(gmdat->gmenu.desc);
		    gmenu2.dnum = swapW(gmdat->gmenu.dnum);
		    gmenu2.nitem = swapW(gmdat->gmenu.nitem);
		    for (l = 0 ; l < gmdat->gmenu.nitem ; l++) {
			gmenu2.r[l].c.left =
			    swapH(gmdat->gmenu.r[l].c.left);
			gmenu2.r[l].c.top =
			    swapH(gmdat->gmenu.r[l].c.top);
			gmenu2.r[l].c.right =
			    swapH(gmdat->gmenu.r[l].c.right);
			gmenu2.r[l].c.bottom
			    = swapH(gmdat->gmenu.r[l].c.bottom);
		    }
		    if ((err = wri_rec(myfd, soffset,
				       (B *)&gmenu2,
				       size, NULL, NULL,
				       (UH)NULL)) < 0) {
			printerror(3);
			return;
		    }
		    soffset += size;
		    tcsize = gmdat->ptrlen;
		    if (changeendian) {
			tf2 = (H *)malloc(tcsize);
			tf3 = (H *)gmdat->gmenu.ptr;
			for (l = 0 ; l < tcsize / sizeof(H) ; l++) {
			    tf2[l] = swapH(tf3[l]);
			}
			if ((err = wri_rec(myfd, soffset, (B *)tf2,
					   tcsize, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
			free(tf2);
		    }
		    else {
			if ((err = wri_rec(myfd, soffset,
					   (B *)gmdat->gmenu.ptr,
					   tcsize, NULL, NULL,
					   (UH)NULL)) < 0) {
			    printerror(3);
			    return;
			}
		    }
		    soffset += tcsize;
		    numindex.size = size + tcsize;
		    break;		    
		case PANEL_DATA:
		    pnldat = (PANELDATA *)(data[i][j].ptr);
		    size = sizeof(PANEL) - sizeof(PNL_ITEM *);
		    panel2.oframe = swapW(pnldat->panel.oframe);
		    panel2.iframe = swapW(pnldat->panel.iframe);
		    panel2.bgpat = swapW(pnldat->panel.bgpat);
		    panel2.r.c.left = swapH(pnldat->panel.r.c.left);
		    panel2.r.c.top = swapH(pnldat->panel.r.c.top);
		    panel2.r.c.right = swapH(pnldat->panel.r.c.right);
		    panel2.r.c.bottom = swapH(pnldat->panel.r.c.bottom);
		    panel2.defsw = swapW(pnldat->panel.defsw);
		    panel2.nitem = swapW(pnldat->panel.nitem);

		    if ((err = wri_rec(myfd, soffset,
				       (B *)&panel2,
				       size, NULL, NULL,
				       (UH)NULL)) < 0) {
			printerror(3);
			return;
		    }
		    soffset += size;
		    size2 = sizeof(PNL_ITEM) * pnldat->panel.nitem;
		    /* $BFbIt%G%#%9%/%j%W%?$N$_BP1~(B */
		    for (l = 0 ; l < pnldat->panel.nitem ; l++) {
			pnlitem2[l].itype =
			    swapW(pnldat->panel.item[l].itype);
			pnlitem2[l].info =
			    swapW(pnldat->panel.item[l].info);
			pnlitem2[l].ir.c.left =
			    swapH(pnldat->panel.item[l].ir.c.left);
			pnlitem2[l].ir.c.top =
			    swapH(pnldat->panel.item[l].ir.c.top);
			pnlitem2[l].ir.c.right =
			    swapH(pnldat->panel.item[l].ir.c.right);
			pnlitem2[l].ir.c.bottom =
			    swapH(pnldat->panel.item[l].ir.c.bottom);
			pnlitem2[l].desc =
			    swapW(pnldat->panel.item[l].desc);
			pnlitem2[l].dnum =
			    swapW(pnldat->panel.item[l].dnum);
		    }
		    if ((err = wri_rec(myfd, soffset,
				       (B *)pnlitem2,
				       size2, NULL, NULL,
				       (UH)NULL)) < 0) {
			printerror(3);
			return;
		    }
		    soffset += size2;
		    numindex.size = size + size2;
		    break;		    
		}
		numindex.size = swapW(numindex.size);
		if ((err = wri_rec(myfd, offset, (B *)&numindex,
				   sizeof(DNUM_INX), NULL, NULL,
				   (UH)NULL)) < 0) {
		    printerror(3);
		    return;
		}
		offset += sizeof(DNUM_INX);
	    }
printf(" ok.\n");
	}
    }
    if (!changeendian) {
	printf("dcls_dat %d\n",dcls_dat(dfid));	
	dfid = dopn_dat(&dboxlnk);
	printf("dfid %d\n", dfid);
    }
}

void savescenedata(W bwid)
{
    /* $B%7!<%s%G!<%?$N%G!<%?9=B$(B
       $B%7!<%s%G!<%?$O%?%$%W(B31$B$N%l%3!<%I$K5-=R$9$k(B
       $B:G=i$N(B10$BJ8;z(B x.x $B$O%P!<%8%g%sHV9f(B
         SDATver1.4
       
       W   $B%7!<%sHV9f(B(-1$B$O%G!<%?$N=*N;$rI=$9(B)
       W   $B%7!<%s$N%G!<%??t(B
         W   $B%?%$%W(B
         W   ID
         PNT $BI=<(:8>e:BI8(B
         W   $B%Q!<%D3JG<G[NsHV9f(B
	 $B$3$l$r$=$N%7!<%s%G!<%?$N?t$@$17+$jJV$9(B
	 */

    B headder[10];
    SCENEDATAver1_4 sdat;
    W i, first, num, err, offset, numoffset, scenenum, counter, recordtype, tmpi;
    CDATA *cdatptr;
    
    first = 1;
    recordtype = (changeendian) ? 29 : 31;
    while (1) {       
	err = fnd_rec(myfd, (first) ? F_TOPEND : F_NFWD,
		      1 << recordtype, (UH)NULL, NULL);
	first = 0;
	if (err == recordtype) {
	    if ((err = rea_rec(myfd, 0, (B *)&headder,
			       sizeof(B) * 10, NULL, (UH)NULL)) < 0) {
		printerror(2);
		return;
	    }
	    if (!strncmp(headder, "SDATver", 7)) {
		del_rec(myfd);
		break;
	    }
	}
	else {
	    break;
	}
    }
    strcpy(headder, "SDATver1.4");
    if ((err = apd_rec(myfd, (B *)&headder,
		       sizeof(B) * 10, recordtype, 0, (UH)NULL)) < 0) {
	printerror(3);
	return;
    }
    offset = sizeof(B) * 10;
    see_rec(myfd, -1, -1, NULL);
    
    scenenum = 0;
    for (i = 0 ; i < MAXSCENENUM ; i++) {
	if (cdata[i].data) {
	    scenenum++;
	}
    }

    counter = 0;
    for (i = 0 ; i < MAXSCENENUM ; i++) {
	num = 0;
	if (cdatptr = cdata[i].data) {
	    printf("saving scenedata %d\n", i);
 	    set_window_bar(bwid, counter, scenenum);
            numoffset = offset;
	    /* $B%@%_!<!#%l%3!<%I%5%$%:$rA}$d$9I,MW$"$j(B */
	    if ((err = wri_rec(myfd, numoffset, (B *)&sdat,
			  sizeof(W) * 2, NULL, NULL, (UH)NULL)) < 0) {
		printerror(3);
		return;
	    }
            offset += sizeof(W) * 2;
	    while (cdatptr) {
		if (changeendian) {
		    sdat.type        = cdatptr->type;
		    sdat.id          = swapW(cdatptr->id);
		    sdat.r.c.left    = swapH(cdatptr->r.c.left);
		    sdat.r.c.top     = swapH(cdatptr->r.c.top);
		    sdat.r.c.right   = swapH(cdatptr->r.c.right);
		    sdat.r.c.bottom  = swapH(cdatptr->r.c.bottom);
		    sdat.pnum        = swapH(cdatptr->pnum);
		    sdat.dispmode    = cdatptr->dispmode;
		    sdat.mojifgcolor = swapW(cdatptr->mojifgcolor);
		    sdat.mojibgcolor = swapW(cdatptr->mojibgcolor);
		    sdat.mojisizex   = cdatptr->mojisize.x;
		    sdat.mojisizey   = cdatptr->mojisize.y;
		    sdat.mojiattr    = swapW(cdatptr->mojiattr);
		}
		else {
		    sdat.type        = cdatptr->type;
		    sdat.id          = cdatptr->id;
		    sdat.r           = cdatptr->r;
		    sdat.pnum        = cdatptr->pnum;
		    sdat.dispmode    = cdatptr->dispmode;
		    sdat.mojifgcolor = cdatptr->mojifgcolor;
		    sdat.mojibgcolor = cdatptr->mojibgcolor;
		    sdat.mojisizex   = cdatptr->mojisize.x;
		    sdat.mojisizey   = cdatptr->mojisize.y;
		    sdat.mojiattr    = cdatptr->mojiattr;
		}
		if ((err = wri_rec(myfd, offset, (B *)&sdat,
			    sizeof(SCENEDATAver1_4),
				   NULL, NULL, (UH)NULL)) < 0) {
		    printerror(3);
		    return;
		}
		offset += sizeof(SCENEDATAver1_4);
		num++;
		cdatptr = cdatptr->nlnk;
	    }
	    tmpi = (changeendian) ? swapW(i): i;
	    if ((err = wri_rec(myfd, numoffset, (B *)&tmpi,
			    sizeof(W), NULL, NULL, (UH)NULL)) < 0) {
		printerror(3);
		return;
	    }
	    numoffset += sizeof(W);
	    tmpi = (changeendian) ? swapW(num) : num;
	    if ((err = wri_rec(myfd, numoffset, (B *)&tmpi,
			    sizeof(W), NULL, NULL, (UH)NULL)) < 0) {
		printerror(3);
		return;
	    }
	    counter++;
	}
    }
    i = -1;
    tmpi = (changeendian) ? swapW(i) : i;
    if ((err = wri_rec(myfd, offset, (B *)&tmpi,
		       sizeof(W), NULL, NULL, (UH)NULL)) < 0) {
	printerror(3);
	return;
    }
}

H swapH(H i)
{
    return (changeendian) ? swap_H(i) : i;
}

W swapW(W i)
{
    return (changeendian) ? swap_W(i) : i;
}

