#include "databox.h"
#include "scene.h"

extern COLOR colmap[256];

void initscenedata()
{
    W i;
    
    for (i = 0 ; i < MAXSCENENUM ; i++) {
	scenedata[i].num  = 0;
	scenedata[i].sdat = NULL;
    }

    for (i = 1 ; i < 11 ; i++) {
	root[i] = NULL;
    }
}

void loadscenedata(W fd)
{
    B headder[11];
    W i, first, ok, num, err, offset;
    SCENEDATAver1_0 sdatver1_0;
    SCENEDATAver1_1 sdatver1_1;
    SCENEDATAver1_2 sdatver1_2;
    SCENEDATAver1_3 sdatver1_3;

    headder[10] = 0;
    first = 1;
    ok = 0;
    while (1) {       
	err = fnd_rec(fd, (first) ? F_TOPEND : F_NFWD,
		      1 << 31, (UH)NULL, NULL);
	first = 0;
	if (err == 31) {
	    if ((err = rea_rec(fd, 0, (B *)&headder,
			       sizeof(B) * 10, NULL, (UH)NULL)) < 0) {
		printerror(2);
		return;
	    }
	    if (!strncmp(headder, "SDATver1.0", 10)) {
		ok = 1;
		break;
	    }
	    if (!strncmp(headder, "SDATver1.1", 10)) {
		ok = 2;
		break;
	    }
	    if (!strncmp(headder, "SDATver1.2", 10)) {
		ok = 3;
		break;
	    }
	    if (!strncmp(headder, "SDATver1.3", 10)) {
		ok = 4;
		break;
	    }
	    if (!strncmp(headder, "SDATver1.4", 10)) {
		ok = 5;
		break;
	    }
	}
	else {
	    break;
	}
    }

    if (!ok) {
	printf("no scene data\n");
	return;
    }
    else {
	printf("scene data %s\n", headder);
    }

    offset = sizeof(B) * 10;
    while (1) {
	if ((err = rea_rec(fd, offset, (B *)&num,
			   sizeof(W), NULL, NULL)) < 0) {
	    printerror(3);
	    return;
	}
	if (num == -1) {
	    break;
	}
	offset += sizeof(W);
	if ((err = rea_rec(fd, offset, (B *)&(scenedata[num].num),
			   sizeof(W), NULL, NULL)) < 0) {
	    printerror(3);
	    return;
	}
	offset += sizeof(W);

	scenedata[num].sdat =
	    (SCENEDATAver1_4 *)malloc(sizeof(SCENEDATAver1_4) *
				      scenedata[num].num);
	switch (ok) {
	case 1: /* ver1.0 */
	    for (i = 0 ; i < scenedata[num].num ; i++) {
		if ((err = rea_rec(fd, offset, (B *)&sdatver1_0,
				   sizeof(SCENEDATAver1_0),
				   NULL, NULL)) < 0) {
		    printerror(3);
		    return;
		}	
		scenedata[num].sdat[i].type        = sdatver1_0.type;
		scenedata[num].sdat[i].id          = sdatver1_0.id;
		scenedata[num].sdat[i].r           = sdatver1_0.r;
		scenedata[num].sdat[i].pnum        = sdatver1_0.pnum;
		scenedata[num].sdat[i].dispmode    = G_STORE;
		scenedata[num].sdat[i].mojifgcolor = 255;
		scenedata[num].sdat[i].mojibgcolor = 0;
		scenedata[num].sdat[i].mojisizex   = 16;
		scenedata[num].sdat[i].mojisizey   = 16;
		scenedata[num].sdat[i].mojiattr    = 0;		
		offset += sizeof(SCENEDATAver1_0);
	    }
	    break;
	case 2: /* ver1.1 */
	    for (i = 0 ; i < scenedata[num].num ; i++) {
		if ((err = rea_rec(fd, offset, (B *)&sdatver1_1,
				   sizeof(SCENEDATAver1_1),
				   NULL, NULL)) < 0) {
		    printerror(3);
		    return;
		}	
		scenedata[num].sdat[i].type        = sdatver1_1.type;
		scenedata[num].sdat[i].id          = sdatver1_1.id;
		scenedata[num].sdat[i].r           = sdatver1_1.r;
		scenedata[num].sdat[i].pnum        = sdatver1_1.pnum;
		scenedata[num].sdat[i].dispmode    = G_STORE;
		scenedata[num].sdat[i].mojifgcolor = sdatver1_1.mojifgcolor;
		scenedata[num].sdat[i].mojibgcolor = sdatver1_1.mojibgcolor;
		scenedata[num].sdat[i].mojisizex   = sdatver1_1.mojisizex;
		scenedata[num].sdat[i].mojisizey   = sdatver1_1.mojisizey;
		scenedata[num].sdat[i].mojiattr    = sdatver1_1.mojiattr;
		offset += sizeof(SCENEDATAver1_1);
	    }
	    break;
	case 3: /* ver1.2 */
	    for (i = 0 ; i < scenedata[num].num ; i++) {
		if ((err = rea_rec(fd, offset, (B *)&sdatver1_2,
				   sizeof(SCENEDATAver1_2),
				   NULL, NULL)) < 0) {
		    printerror(3);
		    return;
		}	
		scenedata[num].sdat[i].type        = sdatver1_2.type;
		scenedata[num].sdat[i].id          = sdatver1_2.id;
		scenedata[num].sdat[i].r           = sdatver1_2.r;
		scenedata[num].sdat[i].pnum        = sdatver1_2.pnum;
		scenedata[num].sdat[i].dispmode    = sdatver1_2.dispmode;
		scenedata[num].sdat[i].mojifgcolor = sdatver1_2.mojifgcolor;
		scenedata[num].sdat[i].mojibgcolor = sdatver1_2.mojibgcolor;
		scenedata[num].sdat[i].mojisizex   = sdatver1_2.mojisizex;
		scenedata[num].sdat[i].mojisizey   = sdatver1_2.mojisizey;
		scenedata[num].sdat[i].mojiattr    = sdatver1_2.mojiattr;
		offset += sizeof(SCENEDATAver1_2);
	    }
	    break;
	case 4: /* ver1.3 */
	    for (i = 0 ; i < scenedata[num].num ; i++) {
		if ((err = rea_rec(fd, offset, (B *)&sdatver1_3,
				   sizeof(SCENEDATAver1_3),
				   NULL, NULL)) < 0) {
		    printerror(3);
		    return;
		}	
		scenedata[num].sdat[i].type        = sdatver1_3.type;
		scenedata[num].sdat[i].id          = sdatver1_3.id;
		scenedata[num].sdat[i].r           = sdatver1_3.r;
		scenedata[num].sdat[i].pnum        = sdatver1_3.pnum;
		scenedata[num].sdat[i].dispmode    = sdatver1_3.dispmode;
		scenedata[num].sdat[i].mojifgcolor = sdatver1_3.mojifgcolor;
		scenedata[num].sdat[i].mojibgcolor = sdatver1_3.mojibgcolor;
		scenedata[num].sdat[i].mojisizex   = sdatver1_3.mojisizex;
		scenedata[num].sdat[i].mojisizey   = sdatver1_3.mojisizey;
		scenedata[num].sdat[i].mojiattr    = sdatver1_3.mojiattr;
		offset += sizeof(SCENEDATAver1_3);
	    }
	    break;
	case 5: /* ver1.4 */
	    if ((err = rea_rec(fd, offset, (B *)scenedata[num].sdat,
			       sizeof(SCENEDATAver1_4) * scenedata[num].num,
			       NULL, NULL)) < 0) {
		printerror(3);
		return;
	    }
	    offset += sizeof(SCENEDATAver1_4) * scenedata[num].num;
	    break;
	}
    }
}

/* wid$B$N<($9%&%#%s%I%&$NIA2h4D6-$N(Br$B$N<($9HO0O$K$K(B scenenum $BHV9f$N%7!<%s$r(B
   $BIA2h!#(B
   $B%Q!<%D$rIA2h$9$k>l9g:n@.$7$?%Q!<%D(BID$B$r(B pid $B%7!<%s%G!<%?(Bpnum$BHVL\$N(B
   $B9`L\$K3JG<!#$=$N9`L\$,(B0$B$G$J$$>l9g$O?7$?$K%Q!<%D$r$D$/$k$3$H$O$7$J$$!#(B
   $BKt!"(Bpnum $B$,(B pmax $B$r1[$($k>l9g$b$J$K$b$7$J$$!#(B
   $B$J$*!"%Q!<%D$NIA2h$O9T$o$J$$(B */
void displayscene(W wid, W scenenum, W *pid, W pmax, RECT *hr)
{
    W 		i, vgid, type, id, pnum, gid, size, dmode;
    BMP 	bmp;
    RECT 	checkrect, r, r2;
    PNT		p2;
    PAT 	*pat;
    CBMP	*cbmp;
    B		*figptr;
    TC		*tptr;
    PARTS	*parts;

    if (hr) {
	r = *hr;
    }
    else {
	wget_wrk(wid, &r);
    }

#if 0    
    gid = wget_gid(wid);
    /* $BIA2h4D6-$N@8@.(B($B$O$_$@$7$?ItJ,$N=hM}$K;H$&(B */
    bmp.bounds = r;
    bmp.planes = 1;
    bmp.pixbits = 0x0808;
    bmalloc(&bmp);

    vgid = gopn_mem(DEV_SCREEN, &bmp, NULL);
#endif    
    vgid = gid = wget_gid(wid);
    
{    
	static	PAT	pat0 = {{0, 16, 16, 0x10ffffff, 0, FILL100}};
	gfil_rec(vgid, r, &pat0, 0, G_STORE);
}
    /*gfil_rec(vgid, r, (PAT *)FILL0, 0, G_STORE);*/

    for (i = 0 ; i < scenedata[scenenum].num ; i++) {
	type  = scenedata[scenenum].sdat[i].type;
	id    = scenedata[scenenum].sdat[i].id;
	pnum  = scenedata[scenenum].sdat[i].pnum;
	r2    = scenedata[scenenum].sdat[i].r;
	dmode = scenedata[scenenum].sdat[i].dispmode;
	orrect(&checkrect, &r, &r2);
	if (!emptyrect(checkrect)) {
	    switch (type) {
	    case PTR_DATA:
		goto NO_DATA;
	    case PAT_DATA:
		if (!searchtree(type, id, (B **)&pat)) {
		    goto NO_DATA;
		}
		gfil_rec(vgid, r2, pat, 0, dmode);
		break;		    
	    case PICT_DATA:
		if (!searchtree(type, id, (B **)&cbmp)) {
		    goto NO_DATA;
		}
		grst_bmp(vgid, &r2, &(cbmp->bmp),
			 &(cbmp->bmp.bounds), NULL, dmode);
		break;
	    case BMAP_DATA:
		if (!searchtree(type, id, (B **)&cbmp)) {
		    goto NO_DATA;
		}
		grst_bmp(vgid, &r2, &(cbmp->bmp),
			 &(cbmp->bmp.bounds), NULL, dmode);
		break;
	    case FIG_DATA:
		if (!searchtree(type, id, (B **)&figptr)) {
		    goto NO_DATA;
		}
		displayfigdata(vgid, figptr, &r2);
		break;
	    case TEXT_DATA:
		if (!searchtree(type, id, (B **)&tptr)) {
		    goto NO_DATA;
		}
		setdeffont(vgid);
		size = tc_strlen(tptr) + 1;
		gdra_stp(vgid, r2.c.left, r2.c.top + 16,
			 tptr, size, dmode);
		break;
	    case PARTS_DATA:
		if (pnum >= pmax) {
		    goto NO_DATA;
		}
		if (!pid[pnum]) {
		    if (!searchtree(type, id, (B **)&parts)) {
			goto NO_DATA;
		    }
		    pid[pnum] = ccre_par(wid, parts);
		    cset_pos(pid[pnum], &r2);
		    /*pid[pnum] = copn_par(wid, id, &(r2.p.lefttop));*/
		}
		break;
	    NO_DATA:
		gfra_rec(vgid, r2, 1, (PAT *)FILL100, 0, G_STORE);
		p2 = r2.p.rightbot;
		p2.x--;
		p2.y--;
		gdra_lin(vgid, r2.p.lefttop, p2, 1, (PAT *)FILL100, G_STORE);
	    }
	}
    }
#if 0
    gcop_bmp(vgid, &r, gid, NULL, NULL, G_STORE);
    gcls_env(vgid);
    bfree(&bmp);
#endif
}

W searchtree(W type, W id, B **ptr)
{
    DATATREE *tptr, **insptr;
    W        err, size, partstype, rsize, rsize2;
    B	     *tmpptr, *tmpptr2;
    
    insptr = &(root[type]);
    tptr = root[type];
    while (tptr) {
	if (id == tptr->id) {
	    *ptr = tptr->ptr;
	    return 1;
	}
	else if (id < tptr->id) {
	    insptr = &(tptr->stree);
	    tptr = tptr->stree;
	}
	else {
	    insptr = &(tptr->ltree);
	    tptr = tptr->ltree;
	}
    }

    if ((err = dget_dtp(type, id, (VOID**)&tmpptr2)) < 0) {
	return 0;
    }
    size = dget_siz(tmpptr2);
    if (type == PARTS_DATA) {
	memcpy(&partstype, tmpptr2, sizeof(W));
	switch (partstype & 0x1f) {
	case TB_PARTS:
	case XB_PARTS:
	    rsize = sizeof(TEXTBOX) -
		((partstype & P_PARTDISP) ? 0 : sizeof(PARTDISP));
//	    tmpptr = malloc(rsize);
	    tmpptr = malloc(sizeof(TEXTBOX)); // YASHIRO
	    (*ptr) = tmpptr;
	    memcpy(tmpptr, tmpptr2, rsize);
	    tmpptr = malloc(size - rsize);
	    memcpy(tmpptr, tmpptr2 + rsize, size - rsize);
	    ((PARTS *)(*ptr))->tb.text = (TC *)tmpptr;
	    break;
	case SB_PARTS:
	    rsize = sizeof(SERBOX) -
		((partstype & P_PARTDISP) ? 0 : sizeof(PARTDISP));
//	    tmpptr = malloc(rsize);
	    tmpptr = malloc(sizeof(SERBOX)); // YASHIRO
	    (*ptr) = tmpptr;
	    memcpy(tmpptr, tmpptr2, rsize);
	    rsize2 = ((PARTS *)(*ptr))->sb.nfld * sizeof(W);
	    tmpptr = malloc(rsize2);
	    memcpy(tmpptr, tmpptr2 + rsize, rsize2);
	    ((PARTS *)(*ptr))->sb.cv = (W *)tmpptr;
	    tmpptr = malloc(size - rsize - rsize2);
	    memcpy(tmpptr, tmpptr2 + rsize + rsize2, size - rsize - rsize2);
	    ((PARTS *)(*ptr))->sb.fmt = (TC *)tmpptr;
	    break;
	case AS_PARTS:
	case MS_PARTS:
	case WS_PARTS:
	case SS_PARTS:
	    rsize = sizeof(SWSEL) -
		((partstype & P_PARTDISP) ? 0 : sizeof(PARTDISP));
//	    tmpptr = malloc(rsize);
	    tmpptr = malloc(sizeof(SWSEL)); // YASHIRO
	    (*ptr) = tmpptr;
	    memcpy(tmpptr, tmpptr2, rsize);
	    tmpptr = malloc(size - rsize);
	    memcpy(tmpptr, tmpptr2 + rsize, size - rsize);
	    ((PARTS *)(*ptr))->ss.name = (TC *)tmpptr;
	    break;	    
	default:
	    tmpptr = malloc(size);
	    (*ptr) = tmpptr;
	    memcpy(tmpptr, tmpptr2, size);
	    break;
	}
    }
    else {
	if (size < 0) {
	    return 0;
	}
	tmpptr = malloc(size);
	(*ptr) = tmpptr;
	memcpy(tmpptr, tmpptr2, size);
    }
    tmpptr = (B *)malloc(sizeof(DATATREE));
    (*insptr) = (DATATREE *)(tmpptr);
    (*insptr)->id    = id;
    (*insptr)->ptr   = *ptr;
    (*insptr)->stree = NULL;
    (*insptr)->ltree = NULL;
    return 1;
}
	
/* figdata$B$N(BFIG_DATA$B$r(B rptr == NULL$B$N>l9g$=$N(BFIG$B$NK\Mh$N0LCV!"$=$&$G$J$$>l9g(B
   $B$O(B*rptr$B$N0LCV$KIA2h$9$k(B */
void displayfigdata(W gid, B *figdata, RECT *rptr)
{
    W   i, k;
    PNT pnt, start, end;
    PAT *patptr;
    POLY *poly;
    RECT r, r2;
    
    TF_RECT     *tfrect;
    TF_RRECT    *tfrrect;
    TF_SEC      *tfsec;
    TF_POLYGON  *tfpolygon;
    TF_POLYLINE *tfpolyline;
    TF_LINE     *tfline;
    TF_ARC      *tfarc;
    
    tfrect     = (TF_RECT *)figdata;
    tfrrect    = (TF_RRECT *)figdata;
    tfsec      = (TF_SEC *)figdata;
    tfpolygon  = (TF_POLYGON *)figdata;
    tfpolyline = (TF_POLYLINE *)figdata;
    tfline     = (TF_LINE *)figdata;
    tfarc      = (TF_ARC *)figdata;

    if (rptr) {
	r = *rptr;
    }
    /* $BEI$j$D$V$7(B */
    /* $BOH(B */
    switch (tfrect->subid) {
    case TF_RECT_SID:
    case TF_OVAL_SID:
	if (!rptr) {
	    r = tfrect->frame;
	}
	break;
    case TF_RRECT_SID:
	if (!rptr) {
	    r = tfrrect->frame;
	}
	break;
    case TF_SEC_SID:
    case TF_CHORD_SID:
	if (!rptr) {
	    r = tfrect->frame;
	    start = tfsec->start;
	    end   = tfsec->end;
	}
	else {
	    start.x = tfsec->start.x + r.c.left - tfsec->frame.c.left;
	    start.y = tfsec->start.y + r.c.top - tfsec->frame.c.top;
	    end.x   = tfsec->end.x + r.c.left - tfsec->frame.c.left;
	    end.y   = tfsec->end.y + r.c.top - tfsec->frame.c.top;
	}
	break;
    case TF_ARC_SID:
	if (!rptr) {
	    r = tfarc->frame;
	    start = tfarc->start;
	    end   = tfarc->end;
	}
	else {
	    start.x = tfarc->start.x + r.c.left - tfarc->frame.c.left;
	    start.y = tfarc->start.y + r.c.top - tfarc->frame.c.top;
	    end.x   = tfarc->end.x + r.c.left - tfarc->frame.c.left;
	    end.y   = tfarc->end.y + r.c.top - tfarc->frame.c.top;
	}
	break;
    case TF_POLYGON_SID:
	if (!rptr) {
	    poly = (POLY *)&(tfpolygon->round);
	}
	else {
	    poly = (POLY *)malloc(sizeof(POLY) + (tfpolygon->np - 1) *
				       sizeof(PNT));
	    poly->round = tfpolygon->round;
	    poly->size  = tfpolygon->np;
	    getfigrect(figdata, &r2);
	    for (i = 0 ; i < tfpolygon->np ; i++) {
		poly->pt[i].x = tfpolygon->pt[i].x + r.c.left - r2.c.left;
		poly->pt[i].y = tfpolygon->pt[i].y + r.c.top - r2.c.top;
	    }
	}
	break;
    case TF_POLYLINE_SID:
	if (!rptr) {
	    poly = (POLY *)&(tfpolyline->round);
	}
	else {
	    poly = (POLY *)malloc(sizeof(POLY) + (tfpolyline->np - 1) *
				       sizeof(PNT));
	    poly->round = tfpolyline->round;
	    poly->size  = tfpolyline->np;
	    getfigrect(figdata, &r2);
	    for (i = 0 ; i < tfpolyline->np ; i++) {
		poly->pt[i].x = tfpolyline->pt[i].x + r.c.left - r2.c.left;
		poly->pt[i].y = tfpolyline->pt[i].y + r.c.top - r2.c.top;
	    }
	}
	break;
    case TF_LINE_SID:
	if (!rptr) {
	    start = tfline->start;
	    end   = tfline->end;
	}
	else {
	    getfigrect(figdata, &r2);
	    start.x = tfline->start.x + r.c.left - r2.c.left;
	    start.y = tfline->start.y + r.c.top - r2.c.top;
	    end.x   = tfline->end.x + r.c.left - r2.c.left;
	    end.y   = tfline->end.y + r.c.top - r2.c.top;
	}
	break;
    }
    /* $B%Q%?!<%s(B */
    switch (tfrect->subid) {
    case TF_RECT_SID:
    case TF_OVAL_SID:
    case TF_SEC_SID:
    case TF_CHORD_SID:
    case TF_POLYGON_SID:
	if (tfrect->f_pat < 256) {
	    pat.spat.fgcol = colmap[tfrect->f_pat];
	    patptr = &pat;
	}	
	else {
	    k = searchdnum(PAT_DATA, tfrect->f_pat, NULL);
	    if (k < 0) {
		goto ERR_FIG;
	    }
	    patptr = (PAT *)data[PAT_DATA][k].ptr;
	}
	break;
    case TF_RRECT_SID:
	if (tfrrect->f_pat < 256) {
	    pat.spat.fgcol = colmap[tfrrect->f_pat];
	    patptr = &pat;
	}	
	else {
	    k = searchdnum(PAT_DATA, tfrrect->f_pat, NULL);
	    if (k < 0) {
		goto ERR_FIG;
	    }
	    patptr = (PAT *)data[PAT_DATA][k].ptr;
	}
	break;
    }
    /* $BEI$j$D$V$9(B */
    switch(tfrect->subid) {
    case TF_RECT_SID:
	gfil_rec(gid, r, patptr, 0, tfrect->mode);
	break;
    case TF_OVAL_SID:
	gfil_ovl(gid, r, patptr, 0, tfrect->mode);
	break;
    case TF_RRECT_SID:
	gfil_rrc(gid, r, tfrrect->rh, tfrrect->rv, patptr, 0, tfrrect->mode);
	break;
    case TF_SEC_SID:
	gfil_sec(gid, r, start, end, patptr, 0, tfrect->mode);
	break;
    case TF_CHORD_SID:
	gfil_cho(gid, r, start, end, patptr, 0, tfrect->mode);
	break;
    case TF_POLYGON_SID:
	gfil_pol(gid, poly, patptr, tfpolygon->mode);
	break;
    }
	    
    /* $BOH%Q%?!<%s(B */
    /* $B%Q%?!<%s(B */
    switch (tfrect->subid) {
    case TF_RECT_SID:
    case TF_OVAL_SID:
    case TF_SEC_SID:
    case TF_CHORD_SID:
    case TF_POLYGON_SID:
    case TF_LINE_SID:
    case TF_ARC_SID:
    case TF_POLYLINE_SID:
	if (tfrect->l_pat < 256) {
	    pat.spat.fgcol = colmap[tfrect->l_pat];
	    patptr = &pat;
	}
	else {
	    k = searchdnum(PAT_DATA, tfrect->l_pat, NULL);
	    if (k < 0) {
		goto ERR_FIG;
	    }
	    patptr = (PAT *)data[PAT_DATA][k].ptr;
	}
	break;
    case TF_RRECT_SID:
	if (tfrrect->l_pat < 256) {
	    pat.spat.fgcol = colmap[tfrrect->l_pat];
	    patptr = &pat;
	}	
	if (tfrrect->l_pat < 256) {
	    pat.spat.fgcol = colmap[tfrrect->l_pat];
	    patptr = &pat;
	}	
	else {
	    k = searchdnum(PAT_DATA, tfrrect->l_pat, NULL);
	    if (k < 0) {
		goto ERR_FIG;
	    }
	    patptr = (PAT *)data[PAT_DATA][k].ptr;
	}
	break;
    }
    /* $BOHIA2h(B */
    switch (tfrect->subid) {
    case TF_RECT_SID:
	gfra_rec(gid, r, tfrect->l_atr, patptr, 0, tfrect->mode);
	break;
    case TF_OVAL_SID:
	gfra_ovl(gid, r, tfrect->l_atr, patptr, 0, tfrect->mode);
	break;
    case TF_RRECT_SID:	
	gfra_rrc(gid, r, tfrrect->rh, tfrrect->rv,
		 tfrrect->l_atr, patptr, 0, tfrrect->mode);
	break;
    case TF_SEC_SID:
	gfra_sec(gid, r, start, end, tfsec->l_atr,
		 patptr, 0, tfsec->mode);
	break;
    case TF_CHORD_SID:
	gfra_cho(gid, r, start, end, tfsec->l_atr,
		 patptr, 0, tfsec->mode);
	break;
    case TF_POLYGON_SID:
	gfra_pol(gid, poly, tfpolygon->l_atr, patptr, tfpolygon->mode);
	if (rptr) {
	    free(poly);
	}
	break;
    case TF_LINE_SID:
	gdra_lin(gid, start, end, tfline->l_atr,
		 patptr, tfline->mode);
	break;
    case TF_ARC_SID:
	gdra_arc(gid, r, start, end, tfarc->l_atr,
		 patptr, 0, tfarc->mode);
	break;
    case TF_POLYLINE_SID:
	gdra_pln(gid, poly, tfpolyline->l_atr, patptr, tfpolyline->mode);
	if (rptr) {
	    free(poly);
	}
	break;
    }
    return;
    
 ERR_FIG:
    gfil_rec(gid, r, (PAT *)FILL0, 0, G_STORE);
    gfra_rec(gid, r, 1, (PAT *)FILL100, 0, G_STORE);
    pnt = r.p.rightbot;
    pnt.x--;
    pnt.y--;
    gdra_lin(gid, r.p.lefttop, pnt, 1,
	     (PAT *)FILL100, G_STORE);
    
}
